/*
History:
   jt28Feb11 Copied over from HPSMU widgets_ext.js
*/

var g_popupWindows = new Array;

//-----------------------------------------------------------------------------
// CPopupWindow
//
// Summary: Creates and manages a popup window
// Constructor:
//          sPopupURL - The URL of the document to load into the popup
//          sWindowName - The name of the popup window to be created
//          sFeatures - Popup window features (for window.open)
//-----------------------------------------------------------------------------
// Try this code here in order to aviod having a global counter
var CPopupWindow = (function()
{
   var sm_instCounter = 0;  // This behaves as a static member function
   // static member function that returns the next number in the counter
   function getNextInstance() { return sm_instCounter++; }
   // This is the real constructor
   function Constructor(sPopupURL, sWindowName, sFeatures)   
   {
      this.m_sPopupURL = sPopupURL || "popup.htm";
      this.m_sWindowName = sWindowName || "SMUpu" + getNextInstance();
      this.m_sFeatures = sFeatures || "menubar=no,scrollbars=yes,resizable=no,status=no,toolbar=no,location=no,titlebar=no,height=600,width=800";
      this.m_pWindow = null;
   }
   // Return the real construtor   
   return Constructor;
})(); // and instantiate the function

// Show the popup window
CPopupWindow.prototype.showPopup = function()
{
   this.m_pWindow = window.open(this.m_sPopupURL, this.m_sWindowName, this.m_sFeatures);
   // Add to global list of popup window references so that they can be closed when the main page is closed
   g_popupWindows[g_popupWindows.length] = this.m_pWindow;
};

// Wait for a specified DOM element to be created on the popup window
// sElementName   : The name of the element (in the popup window) to wait for
// Note: These wait functions were needed because Firefox was returning 
//       immediately, causing errors.
CPopupWindow.prototype.popupDOMWait = function(sElementName, wRetryInterval)
{
   // Save a reference to ourselves so the private member can access us
   var oPopup = this;
   var wTimeoutInterval = wRetryInterval || 200;
   // Create a closure that can be called by setTimeout
   function WaitFunction()
   {
      if (oPopup.m_pWindow)
      {
         var popupElement = null;
         try
         {
            if (oPopup.m_pWindow.document && oPopup.m_pWindow.document.getElementById(sElementName))
            {
               popupElement = oPopup.m_pWindow.document.getElementById(sElementName);
            }
         }
         catch (e)
         {
         }
         // Wait until the passed in element name is created and available
         if (!popupElement)
         {
            try
            {
               // Only try again if the window has not been closed
               if (!oPopup.m_pWindow.closed)
               {
                  setTimeout(WaitFunction, wTimeoutInterval);
               }
            }
            catch (e)
            {
            }
         }
         else
         {
            // Once the element is accessible,
            oPopup.postDOMWait(sElementName);
         }
      }
   }
   WaitFunction();
}
// Callback function for popupDOMWait
// sElementName : The name of the element that the wait function was called with
CPopupWindow.prototype.postDOMWait = function(sElementName) {}

// Set the popup window's title
CPopupWindow.prototype.setPopupTitle = function(sTitle)
{
   if (this.m_pWindow && this.m_pWindow.document)
   {
      this.m_pWindow.document.title = sTitle;
   }
}
// Call a function in the popup window
// fName    : function name (type : string)
// fParams  : Optional parameter list
CPopupWindow.prototype.callFunction = function(fName, fParams)
{
   var sCommand = "this.m_pWindow." + fName + "(";
   if (fParams)
      sCommand += fParams;
   sCommand += ")";
   try
   {
      eval(sCommand);
   }
   catch(e) {}
}

CPopupWindow.CloseAllPopups = function()
{
   for (var i=0; i<g_popupWindows.length; ++i)
   {
      if(g_popupWindows[i].closed == false)
      {
         g_popupWindows[i].close();
      }
   }
}

//-----------------------------------------------------------------------------
// CPopupWindow End
//-----------------------------------------------------------------------------
