/*
History:
   jt07Dec10 Copied over from HPSMU requestor.js
*/

function CRequestor()
{
   var m_requestor            = false; // XMLHttpRequest object
   var m_pfCallback           = false; // possible callback function that the user specifies.
   var m_sFalseDataResponse   = "FalseDataResponse";
   this.m_attrList            = new Array(); // Name/value pairs
   var m_sRequestType         = "";
   // Request Callback Support
   var m_cbInstance           = 0;
   var m_cbFunc               = 0;  
   var m_dsw = 0;
   var m_evalResult = true;    // Run the return value through an "eval"

   this.setEvalResult = function(evalResult)
   {
      m_evalResult = evalResult;
   }
   
   this.setRequestType = function(sType)
   {
      m_sRequestType = sType;
   }

   this.Constructor = function()
   {
      if (window.XMLHttpRequest)
      {
         try { m_requestor = new XMLHttpRequest(); }
         catch (e)
         {
            alert("Error creating XMLHttpRequest object");
            m_requestor = false;
         }
      }
      else if (window.ActiveXObject)
      {
         try { m_requestor = new ActiveXObject("Microsoft.XMLHTTP"); }
         catch (e)
         {
            alert("Error creating Microsoft.XMLHTTP object");
            m_requestor = false;
         }
      }
   }
   this.Constructor();

   //    requestor.getDevice(<uniqueId>);
   //    requestor.getDevice(<uniqueId>, callBackFunc);
   //    requestor.getDevice(<uniqueId>, this/obj, "callBackFunc");
   this.executeRequest = function(cbInstance, cbFunc)
   {
      var device; // To be a Device object
      // currently set to synchronous mode, so when this next call
      // comes back, our data will be ready to go. 
      var isAsync = false;
      var sURL = m_sRequestType;
      var sParams = this.m_attrList.join("&");
      // Use POST for all requests.
      var sMethodType = "POST";

      if (cbInstance && cbFunc)
      {
         m_cbInstance = cbInstance;
         m_cbFunc = cbFunc;   // public function
         this.sendRequest(sURL, getResult, sMethodType, sParams);
      }
      else if (cbInstance)
      {
         m_cbFunc = cbInstance; // In this case cbInstance is really a private/global function
         this.sendRequest(sURL, getResult, sMethodType, sParams);
      }
      else
      {
         this.sendRequest(sURL, false, sMethodType, sParams);
         return getResult(this.getResponse(), false);
      }
   }   
    
   function getResult(sReturnData, bReturnArray) 
   {
      if ( m_evalResult )
      {
         var returnObject = JSON.parse( sReturnData );
         if (m_cbInstance && m_cbFunc)
         {
            eval("m_cbInstance." + m_cbFunc + "(returnObject)");
         }
         else if (m_cbFunc)
         {
            m_cbFunc(returnObject);
         }
         else
         {
            return returnObject;
         }
      }
      else
      {
         if (m_cbInstance && m_cbFunc)
         {
            eval("m_cbInstance." + m_cbFunc + "(sReturnData)");
         }
         else if (m_cbFunc)
         {
            m_cbFunc(sReturnData);
         }
         else
         {
            return sReturnData;
         }
      }
   }

   this.setAttribute = function(name,value)  
   { 
      this.m_attrList[this.m_attrList.length] = name + "=" + value;       
   }

   this.sendRequest = function(sURL, pfCallback, sMethodType, sParams)
   {
      if (m_requestor)
      {
         var x_date = new Date();
         x_startRequestTime = x_date.getTime();
         if (pfCallback)
         {
            m_pfCallback = pfCallback;
            m_requestor.onreadystatechange = getResponseHandler;
            m_requestor.open(sMethodType, sURL, true); // Asynchronous
         }
         else
         {
            m_requestor.open(sMethodType, sURL, false); // Synchronous
         }
         m_requestor.send(sParams);
      }
   }
   
   function getResponseData()
   {
      var sResponseText=m_sFalseDataResponse;
      if (m_requestor.readyState == 4) 
      {
         if(m_requestor.status == 200 || m_requestor.status == 0) 
         {
            sResponseText = m_requestor.responseText;
         } 
         else if (m_requestor.status == 401)
         {
            alert("Cannot process request. Request code not found");
         }
         else
         {         
            alert("Cannot process request. Code: " + m_requestor.status);
         }
      }
      return sResponseText;
   }
   
   function getResponseHandler()
   {
      var sResponseData = getResponseData();
      if((sResponseData != m_sFalseDataResponse) && m_pfCallback)
      {         
         m_pfCallback(sResponseData);
      }
   }
   
   this.getResponse = function()
   {
      return getResponseData();
   }
}

