var AVAction = AVTab2.extend({
   
   initialize: function() {
      AVTab2.prototype.initialize.call(this);
   },
   
   render: function() {
      $(this.el).empty();
      // TODO: make sure to dispose all vcontrols in the following line, and anywhere else where we empty a collection of views.
      this.oVControls = [];
      this.oVCollapsedNote = null;
      // Content header is used for page resizing.
      var oOpHeaderDiv = $('<div/>', {'class':"opHeader"});
      var oOpBodyDiv = $('<div/>', {
         'class':"opBody"
      });
      var oOpBodyInnerDiv = $('<div/>', {
         'class':"opBodyInner"
      });
      var oTriggerInput = $('<input/>', {
         'class': 'trigger',
         'type': 'hidden'
      });
      var oOpBodyWidthDiv = $('<div/>', {'class': 'opBodyWidth'});
      var oNotesDiv = $('<div/>', {
         'class': 'notes'
      });
      
      oOpBodyDiv.append(oOpBodyInnerDiv);
      oOpBodyDiv.append(GetClearFloatsDiv());
      oOpBodyInnerDiv.append(oOpBodyWidthDiv);
      oOpBodyInnerDiv.append(oNotesDiv);
      $(this.el).append(oOpHeaderDiv);
      $(this.el).append(oOpBodyDiv);
      $(this.el).append(oTriggerInput);
      
      return this;
   },
   
   drawFooter: function() {
      var oOpFooterDiv = $('<div/>', {
         'class':"opFooter"
      });
      var oInfoDiv = $('<div/>', {
         'class':"info"
      });
      var oLoadingDiv = $('<div/>', {
         'class':"loading"
      });
      var oButtonsDiv = $('<div/>', {
         'class':"buttons"
      });
      oOpFooterDiv.append(oInfoDiv);
      oOpFooterDiv.append(oLoadingDiv);
      oOpFooterDiv.append(oButtonsDiv);
      $(this.el).append(oOpFooterDiv);
   },
   
   showLoadingIcon: function() {
      var oLoading = this.$('.loading');
      // Empty and append the DIV each time we want to show the
      // loading icon so that the icon in IE LTE 9 will animate.
      var oIconDiv = $('<div/>',{'class':'HPSSA_ICON_LOADING HPSSA_SPRITE'});
      oLoading.empty().append(oIconDiv);
   },
   
   drawFooterInfoSection: function(sLabel, sValue) {
      var oInfoDiv = this.$('.opFooter .info');
      var oSectionDiv = $('<div/>', {
         'class':'section'
      });
      var oLabelSpan = $('<span/>', {
         'class':'label'
      });
      var oValueSpan = $('<span/>', {
         'class':'value'
      });
      oLabelSpan.html(TranslateString(sLabel) + ": ");
      oValueSpan.html(TranslateString(sValue));
      oSectionDiv.append(oLabelSpan);
      oSectionDiv.append(oValueSpan);
      oInfoDiv.append(oSectionDiv);
   },
   
   updateFooterInfo: function(oVControl) {
      // Empty the footer info container.
      var oInfoDiv = this.$('.opFooter .info').empty();
      var oDeviceIDs = oVControl.getValueArray();
      // Display "Less Info" for selection.
      if (oDeviceIDs.length > 0)
      {
         var oParams = {};
         for (var i=0; i < oDeviceIDs.length; ++i)
         {
            oParams["PV"+i] = oDeviceIDs[i];
         }
         // Set details level to 3 to include the "Less Info".
         oParams["PV"+i] = 3;
         var oReturn = GetDevicesDetails(oParams);
         if (IsDefined(oReturn))
         {
            var oDevice = oReturn.d;
            if (IsDefined(oDevice))
            {
               var oLessInfo;
               for (var i=0; !IsDefined(oLessInfo) && i<oDevice.length; ++i)
               {
                  if (oDevice[i].SectionName == "STR_LESS_INFO")
                  {
                     oLessInfo = oDevice[i];
                     for (var j=0; j<oLessInfo.SectionLabels.length; ++j)
                     {
                        this.drawFooterInfoSection(
                           oLessInfo.SectionLabels[j],
                           oLessInfo.SectionValues[j]
                        );
                     }
                  }
               }
            }
         }
      }
   },
   
   onControlSelectionChange: function(e) {
      var bIsFound = false;
      for (var i=0; !bIsFound && i<this.oVControls.length; ++i)
      {
         var oAttr = this.oVControls[i].model.get('oAttributes');
         bIsFound = IsDefined(oAttr) && oAttr.CONTROL_TYPE == "DriveSelector";
         if (bIsFound)
         {
            this.updateFooterInfo(this.oVControls[i]);
         }
      }
   },

   resizeWidth: function() {
      AVTab2.prototype.resizeWidth.call(this);
      var nControlWidth = this.$('.notes').width();
      this.model.set({'nNoteWidth':nControlWidth});
      if(IsDefined(this.oVControls))
      {
         for (var i=0; i<this.oVControls.length; ++i)
         {
            this.oVControls[i].model.set({'nWidth': nControlWidth});
         }
      }
      if (IsDefined(this.oVCollapsedNote))
      {
         this.oVCollapsedNote.resizeHeight();
      }
   },
   
   resizeHeight: function() {
      //var bPrevHasVerticalScrollBar = oOpBodyDiv.hasVerticalScrollBar();
      AVTab2.prototype.resizeHeight.call(this);
      var oOpHeaderDiv = this.$('.opHeader');
      var oOpFooterDiv = this.$('.opFooter');
      var nHeight = this.model.get('nHeight');
      var nHeaderHeight = IsDefinedAndSet(oOpHeaderDiv.outerHeight()) ? oOpHeaderDiv.outerHeight() : 0;
      var nFooterHeight = IsDefinedAndSet(oOpFooterDiv.outerHeight()) ? oOpFooterDiv.outerHeight() : 0;
      var nOpBodyDivHeight = nHeight - nHeaderHeight - nFooterHeight;
      var oOpBodyDiv = this.$('.opBody');
      oOpBodyDiv.height(nOpBodyDivHeight);
      var nNoteWidth = this.$('.notes').width();
      if (nNoteWidth != this.model.get('nNoteWidth'))
      {
         this.resizeWidth();
      }
   }
   
});

