var AVActionManager = AVTab2.extend({
   
   // Overloaded in avtreetab.js.
   events: {
      // For action buttons.
      "click a.Action": "clickActionButton",
      "click a.Unavailable": "clickUnavailableActionButton",
      "click #viewStatusMessages": "clickViewStatusMessages"
   },

   // 4. Triggered by AVTab1
   refresh: function()
   {
      // oDevice will be out of date upon refresh, so clear it.
      this.model.set({
         'oDevice': null
      });
      this.model.updateDashboard();
      // Do not need to refresh the following objects because
      // render will redraw everything with updated info already.
      //this.addToRefreshQueue(this.oVDeviceStatus);
      //this.addToRefreshQueue(this.oVDeviceConfigSummary);
      //this.executeRefreshQueue();
      this.postRefresh();
   },

   postRefresh: function() {
      this.render();
      this.resize();
      AVTab2.prototype.postRefresh.call(this);
   },

   dispose: function() {
      if (IsDefined(this.oVDeviceStatus))
      {
         this.oVDeviceStatus.dispose();
      }
      if (IsDefined(this.oVDeviceConfigSummary))
      {
         this.oVDeviceConfigSummary.dispose();
      }
      AVTab2.prototype.dispose.call(this);
   },
   
   render: function ()
   {
      // Same as AVAction
      $(this.el).empty();
      // Content header is used for page resizing.
      var oOpHeaderDiv = $('<div/>', {'class':"opHeader"});
      var oOpBodyDiv = $('<div/>', {
         'class':"opBody"
      });
      var oOpBodyInnerDiv = $('<div/>', {
         'class':"opBodyInner"
      });
      var oOpBodyWidthDiv = $('<div/>', {'class': 'opBodyWidth'});
      var oNotesDiv = $('<div/>', {
         'class': 'notes'
      });
      
      oOpBodyDiv.append(oOpBodyInnerDiv);
      oOpBodyDiv.append(GetClearFloatsDiv());
      oOpBodyInnerDiv.append(oOpBodyWidthDiv);
      oOpBodyInnerDiv.append(oNotesDiv);
      $(this.el).append(oOpHeaderDiv);
      $(this.el).append(oOpBodyDiv);

      //AVAction.prototype.render.call(this);
      this.drawAll();
      return this;
   },
   
   // Overload to customize.
   drawAll: function()
   {
      this.drawHeader();
      // Draw widgets on dashboard.
      var oBodyDiv = this.$('.opBodyInner');
      this.drawDashboard(oBodyDiv);
      

      //this.drawLeftColumn(oBodyDiv);
      //this.drawRightColumn(oBodyDiv);
   },

   drawDashboard: function(oParentDiv)
   {
      var oDashboardDiv = $('<div/>', {'class':'dashboard'});
      oParentDiv.append(oDashboardDiv);
      var oDashboard = this.model.get('oDashboard');
      var oSections = oDashboard.Sections;
      for (var i=0; i<oSections.length; ++i)
      {
         this.drawSection(oDashboardDiv, oSections[i]);
      }
   },

   drawSection: function(oParentDiv, oSection)
   {
      var sSectionName = TranslateString(oSection.SectionName);
      var sSectionType = oSection.SectionType;
      var oSectionName = $('<div/>', {'class':'sectionName'});
      oSectionName.append(sSectionName);
      oParentDiv.append(oSectionName);
      var oSectionDiv;
      if (sSectionType == "MESSAGE")
      {
         oSectionDiv = $('<div/>', {'class':'section'});
         var sMessage = oSection.Message;
         oSectionDiv.append(TranslateString(sMessage));
      }
      else if (sSectionType == "TABLE")
      {
         oSectionDiv = $('<table/>', {'class':'section'});
         var nColumnCount = oSectionDiv.ColumnCount;
         var nSectionName = oSectionDiv.SectionName;
         var nSectionType = oSectionDiv.SectionType; // e.g. TABLE
         var oRows = oSection.Rows;
         for (var i=0; i<oRows.length; ++i)
         {
            var oRowDiv = $('<tr/>', {'class':'row'});
            oSectionDiv.append(oRowDiv);
            var oCells = oRows[i];
            for (var j=0; j<oCells.length; ++j)
            {
               var oCell = oCells[j];
               var oCellElements = oCell.Elements;
               var sCellType = oCell.CellType;
               var sCellClass = "cell " + sCellType;
               var oCellDiv = $('<td/>', {'class':sCellClass});
               oRowDiv.append(oCellDiv);
               // Loop through cell items (links have multiple items).
               for (var k=0; k<oCellElements.length; ++k)
               {
                  for (var k=0; k<oCellElements.length; ++k)
                  {
                     var oElement = oCellElements[k];
                     //var sDisplayType = oElement.DisplayType;
                     var sElementType = oElement.ElementType;
                     var sElementClass = "element " + sElementType;
                     var oElementDiv = $('<div/>', {'class':sElementClass});
                     var oElementAttributes = oElement.ElementAttributes;
                     oCellDiv.append(oElementDiv);
                     if (sElementType == "LABEL")
                     {
                        var sDisplayLabel = TranslateString(oElementAttributes.DISPLAY_LABEL);
                        oElementDiv.append(sDisplayLabel);
                     }
                     // TO BE REMOVED.
                     /*else if (sElementType == "CONTROL")
                     {
                        // Display Status Icon
                        var sStatusLevel = "ICON_OVERLAY_STATUS_WARN"; // temp - wendy to remove controls in SAL
                        var sStatusIconClass = 'icon HPSSA_SPRITE ' + sStatusLevel;
                        var oStatusIconDiv = $('<div/>', {'class':sStatusIconClass});
                        oElementDiv.append(oStatusIconDiv);

                        var sActionParam = TranslateString(oElementAttributes.CONTROL_ENABLED);
                        oElementDiv.append(sActionParam);
                     }*/
                     else if (sElementType == "DESCRIPTION")
                     {
                        var sDescriptionContent = TranslateString(oElementAttributes.DESCRIPTION_CONTENT);
                        oElementDiv.append(sDescriptionContent);
                     }
                     else if (sElementType == "STATUS")
                     {
                        // Display Status Icon
                        var sStatusLevel = oElementAttributes.STATUS_LEVEL;
                        if (sStatusLevel == "INFORMATION")
                        {
                           sStatusLevel = "ICON_OVERLAY_STATUS_INFO";
                        }
                        else if (sStatusLevel == "WARNING")
                        {
                           sStatusLevel = "ICON_OVERLAY_STATUS_WARN";
                        }
                        else if (sStatusLevel == "CRITICAL")
                        {
                           sStatusLevel = "ICON_OVERLAY_STATUS_FAIL";
                        }
                        var sStatusIconClass = 'icon HPSSA_SPRITE ' + sStatusLevel;
                        var oStatusIconDiv = $('<div/>', {'class':sStatusIconClass});
                        oElementDiv.append(oStatusIconDiv);

                        // Display Label
                        var sDisplayLabel = TranslateString(oElementAttributes.DISPLAY_LABEL);
                        var oStatusLabel = $('<div/>', {'class':'label'});
                        oStatusLabel.append(sDisplayLabel);
                        oElementDiv.append(oStatusLabel);
                     }
                     else if (sElementType == "UNAVAILABLE_LINK")
                     {
                        var sDisplayLabel = TranslateString(oElementAttributes.DISPLAY_LABEL);
                        var sLinkType = oElementAttributes.LINK_TYPE; // e.g. Unavailable
                        var sReason = oElementAttributes.REASON;
                        var sElementIconClass = "icon";
                        if (sReason == "ATTR_VALUE_UNAVAILABLE_REASON_ENCRYPTION_NEEDS_LOGIN" ||
                            sReason == "ATTR_VALUE_UNAVAILABLE_REASON_ENCRYPTION_LOGIN_TIMEOUT" || 
                            sReason == "ATTR_VALUE_UNAVAILABLE_REASON_ENCRYPTION_NOT_LOGGED_IN" //||
                            //sReason == "ATTR_VALUE_UNAVAILABLE_REASON_INSUFFICIENT_PRIVILEGE"
                            )
                        {
                           // Display lock icon.
                           sElementIconClass += " HPSSA_SPRITE ICON_LOCK";
                        }
                        var oElementIconDiv = $('<div/>', {
                           'class': sElementIconClass
                        });
                        var oElementTable = $('<table/>');
                        var oElementTR = $('<tr/>');
                        var oIconTD = $('<td/>', {'class':'icon'});
                        var oTextTD = $('<td/>', {'class':'text'});
                        var oA = $('<a/>', {
                           'href':'#',
                           'class':sLinkType
                        });
                        oElementDiv.append(oElementTable);
                        oElementTable.append(oElementTR);
                        oElementTR.append(oIconTD);
                        oElementTR.append(oTextTD);
                        oIconTD.append(oElementIconDiv);
                        oTextTD.append(oA);
                        oA.append(sDisplayLabel);
                        
                        // Tooltip
                        var oToolTip = $('<div/>', {'class':'tooltip'});
                        oToolTip.append($('<div/>',
                        {
                           'class': 'UnavailableLinkReason',
                           'html': TranslateString(sReason)
                        }));
                        oToolTip.hide();
                        oTextTD.append(oToolTip);
                        oA.tooltip({
                           "position": "top center"
                        });
                     }
                     else if (sElementType == "ACTION_LINK")
                     {
                        var sActionParam = oElementAttributes.ACTION_PARAM;
                        var sLinkType = oElementAttributes.LINK_TYPE; // e.g. Action
                        var sDisplayLabel = TranslateString(oElementAttributes.DISPLAY_LABEL);
                        var sElementIconClass = "icon";
                        var oElementIconDiv = $('<div/>', {
                           'class': sElementIconClass
                        });
                        var oElementTable = $('<table/>');
                        var oElementTR = $('<tr/>');
                        var oIconTD = $('<td/>', {'class':'icon'});
                        var oTextTD = $('<td/>', {'class':'text'});
                        var oA = $('<a/>', {
                           'href':'#',
                           'id':sActionParam,
                           'class':sLinkType
                        });
                        oElementDiv.append(oElementTable);
                        oElementTable.append(oElementTR);
                        oElementTR.append(oIconTD);
                        oElementTR.append(oTextTD);
                        oIconTD.append(oElementIconDiv);
                        oTextTD.append(oA);
                        oA.append(sDisplayLabel);
                     }
                  }
               }
            }
         }
      }
      oParentDiv.append(oSectionDiv);
   },

   drawColumnWidget: function(oParentDiv, sID)
   {
      var oDiv = $('<div/>', {'id': sID, 'class':'columnWidget'});
      oParentDiv.append(oDiv);
      return oDiv;
   },
   
   drawLeftColumn: function(oParentDiv)
   {
      var oColumnDiv = $('<div/>', {'class':'leftColumn action'});
      oParentDiv.append(oColumnDiv);
      this.drawActionWidget(oColumnDiv);
   },

   clickUnavailableActionButton: function(e) {
      return false;
   },

   // Action buttons will trigger this method. (e.g. Create Array)
   // Currently only used by AVTreeTab.
   clickActionButton: function(e) {
      $(e.currentTarget).blur();
      var sDeviceID = this.model.get("sDeviceID");
      // Get action details.
      var sActionName = e.currentTarget.id;
      var oOpDetails = GetOperationDetails(sActionName,sDeviceID).operationDetails;
      // Display the action operation page in a popup.
      var oMConfigAction = new MConfigAction({
         'sDeviceID': this.model.get('sDeviceID'),
         'oOpDetails':oOpDetails,
         'bIsCombinedOp': false
      });
      var oVConfigAction = new VConfigAction({
         'model':oMConfigAction
      });
      this.$el.trigger("popup", {
         'sType': 'actionConfigPopup',
         'oVContent': oVConfigAction
      });
      
      // TODO: Is this needed?
      oVConfigAction.resize();

      return false;
   },

   drawBox: function(oParentDiv)
   {
      var oBoxWrapper = $('<div/>', {'class': 'boxWrapper'});
      var oBox = $('<div/>', {'class': 'box'});
      oBoxWrapper.append(oBox);
      oParentDiv.append(oBoxWrapper);
      return oBox;
   },

   drawWidgetTitle: function(oParentDiv, sTitle)
   {
      var oTitle = $('<div/>', {'class': 'title'});
      oTitle.append(TranslateString(sTitle));
      oParentDiv.append(oTitle);
      oParentDiv.append(GetClearFloatsDiv());
   },

   // oParentDiv - div to draw action widget in.   
   // bHideNoActions - true to hide widget when no actions exist.
   drawActionWidget: function(oParentDiv, bHideNoActions)
   {
      var oOperationSelectionDiv = $('<div/>', { 'class': "operationSelection" });
      var nNumActions = this.drawActions(oOperationSelectionDiv);
      if (!bHideNoActions || nNumActions > 0)
      {
         var oWidgetDiv = this.drawColumnWidget(oParentDiv, "actionsWidget");
         var oBox = this.drawBox(oWidgetDiv);
         this.drawWidgetTitle(oBox, "STR_ACTIONS");
         oBox.append(oOperationSelectionDiv);
         // If no Actions were drawn, display message.
         if (nNumActions == 0)
         {
            var oNoteDiv = $('<div/>', {'class':'note'});
            oNoteDiv.append(TranslateString("STR_NO_ACTIONS"));
            oOperationSelectionDiv.append(oNoteDiv);
         }
      }
      return nNumActions;
   },

   clickViewStatusMessages: function(e) {
      $(e.currentTarget).blur();
      var oMStatusPopup = new MStatusPopup({
         'sDeviceID': this.model.get('sDeviceID'),
         'oDevice': this.model.get('oDevice')
      });
      var oVStatusPopup = new VStatusPopup({
         'model': oMStatusPopup
      });
      this.$el.trigger("popup", {
         'sType': 'statusPopup',
         'oVContent': oVStatusPopup,
         'bClickOutsideToClose':true
      });
      return false;
   },

   resizeWidth: function() {
      AVTab2.prototype.resizeWidth.call(this);
      var oLeftColumnDiv = this.$('.leftColumn');
      var oRightColumnDiv = this.$('.rightColumn');
      var oOpBodyWidthDiv = this.$('.opBodyWidth');
      var nBodyWidth = oOpBodyWidthDiv.width();
      var nRightColumnMargin = parseInt(oRightColumnDiv.css('margin-left')) + parseInt(oRightColumnDiv.css('margin-right'));;
      var nRightColumnWidth = nBodyWidth - oLeftColumnDiv.outerWidth(true) - nRightColumnMargin;
      oRightColumnDiv.width(nRightColumnWidth);
   },
   
   resizeHeight: function() {
      // Make sure left column does not exceed height of the body so that it would have its own vertical scrollbar.
      AVTab2.prototype.resizeHeight.call(this);

      // From AVAction
      var oOpHeaderDiv = this.$('.opHeader');
      var oOpFooterDiv = this.$('.opFooter');
      var nHeight = this.model.get('nHeight');
      var nHeaderHeight = IsDefinedAndSet(oOpHeaderDiv.outerHeight()) ? oOpHeaderDiv.outerHeight() : 0;
      var nFooterHeight = IsDefinedAndSet(oOpFooterDiv.outerHeight()) ? oOpFooterDiv.outerHeight() : 0;
      var nOpBodyDivHeight = nHeight - nHeaderHeight - nFooterHeight;
      var oOpBodyDiv = this.$('.opBody');
      oOpBodyDiv.height(nOpBodyDivHeight);
      /*var nNoteWidth = this.$('.notes').width();
      if (nNoteWidth != this.model.get('nNoteWidth'))
      {
         this.resizeWidth();
      }*/
      // End AVAction

      var oActionsDiv = this.$('#actionsWidget');
      var oInnerColumnDiv = this.$('#actionsWidget .box');
      var nInnerColumnHeight = oInnerColumnDiv.outerHeight(true);
      var nBodyHeight = oOpBodyDiv.height();
      var oMarginBtm = parseInt(oActionsDiv.css('margin-bottom'));
      var oMarginTop = parseInt(oActionsDiv.css('margin-top'));
      var oBorderBtm = parseInt(oActionsDiv.css('border-bottom-width'));
      var oBorderTop = parseInt(oActionsDiv.css('border-top-width'));
      var nMaxColumnHeight;
      var oLeftColumnDiv = this.$('.leftColumn');
      var oRightColumnDiv = this.$('.rightColumn');
      var nLeftColumnHeight = oLeftColumnDiv.height();
      var nRightColumnHeight = oRightColumnDiv.height();
      // When left column is not longer than right column (meaning no scrollbar on left column)
      // and right column is longer than the parent height (meaning scrollbar on parent body),
      if (nLeftColumnHeight <= nRightColumnHeight && nRightColumnHeight > nBodyHeight)
      {
         nMaxColumnHeight = nRightColumnHeight - oMarginBtm - oMarginTop - oBorderBtm - oBorderTop;
         oActionsDiv.height(nMaxColumnHeight);
      }
      else
      {
         nMaxColumnHeight = nBodyHeight - oMarginBtm - oMarginTop - oBorderBtm - oBorderTop;
         // TODO: Set min-height.
         if (nInnerColumnHeight > nMaxColumnHeight)
         {
            oActionsDiv.height(nMaxColumnHeight);
         }
         else
         {
            oActionsDiv.css('height', '');
         }
      }
      // Resize Width to fix the issues where the reappearing scrollbar
      // would cause the main width to be smaller.
      // This line is required for firefox.
      // Other browsers only need this inside the else conditional above.
      this.resizeWidth();
   }

});