var AVTreeActions = AVTab1.extend({
   
   events: {
      "click .filterGroupHeader a.selectable" : "onChildClick",
      "click .filterGroupSortLists a.selectable" : "onChildClick",
      "refresh .opBody": "onRefresh", // called when popup is closed (Delete Array).
      "click .BackToOverview" : "onBackClick",
      "click .SSDLink" : "onChildClick"
   },
   
   // Called by AVBody.
   refresh: function() {
      // TODO - determine if we need this ClearDeviceSelection() call.
      ClearDeviceSelection();
      this.addToRefreshQueue(this.oVNav);
   },

   postRefresh: function() {
      // Only update the sDeviceID. Don't redraw the page because info
      // displayed from action execution will be lost.
      var sSelectedDeviceID = this.oVNav.getSelectedDeviceID();
      this.oVTab.selectChild(sSelectedDeviceID);
      this.notifyRefreshObservers();
   },

   initialize: function() {
      this.oVNav = null;
      AVTab1.prototype.initialize.call(this);
   },
  
   render: function() {
      $(this.el).empty();
      var oNavDiv = $('<div/>', {'class':'tab2Nav'});
      var oBodyDiv = $('<div/>', {'class':'tab2Body'});
      this.$el.append(oNavDiv);
      this.$el.append(oBodyDiv);
      this.drawNav(oNavDiv);
      this.drawTab(oBodyDiv);
      return this;
   },
   
   // This is triggered when a user dismisses a popup (e.g. Delete Array)
   onRefresh: function (e)
   {
      ClearDeviceSelection();
      this.oVNav.refresh();
      // TODO: Check which item is selected.
      // If selected device no longer exists (delete array/erase logical drive), show overview page.
      var sSelectedDeviceID = this.oVNav.getSelectedDeviceID();
      SelectDevice(sSelectedDeviceID);
      // If device does exist, update its page.
      this.oVTab.selectChild(sSelectedDeviceID);
      return false;
   },
   
   onChildClick: function(e) {
      var o = $(e.currentTarget);
      var sID = e.currentTarget.id;
      var sRel = o.attr("rel");
      /*var oDiv = this.$(e.currentTarget);
      this.clearSelected();
      oDiv.addClass("selected");*/
      this.selectChild(sID, sRel);
      return false;
   },

   onBackClick: function(e) {
      // Currently overloaded in VWearGaugeTreeActions.js
   },

   selectChild: function(sID, sParentID) {
      if (sID == "overview")
      {
         this.oVNav.clearSelected();
         this.oVTab.model.set({'sDeviceID':''});
         this.oVTab.render();
      }
      else
      {
         // Note: If sID is not defined, whatever's stored as the currently selected device will be selected.
         var bResult = this.oVNav.selectChild(sID, sParentID);
         // Draw the tab if the child was successfully selected.
         if (bResult)
         {
            this.oVTab.selectChild(this.oVNav.getSelectedDeviceID());
         }
         // Otherwise display error message and refresh.
         else
         {
            // Display selection not found message in a popup.
            var oMAlertPopup = new MAlertPopup({
               'bRefreshOnClose': true,
               'sMessage': 'STR_DEVICE_NOT_FOUND_REFRESH'
            });
            var oVAlertPopup = new VAlertPopup({
               'model':oMAlertPopup
            });
            this.$el.trigger("popup", {
               'sType': 'alertPopup',
               'oVContent': oVAlertPopup
            });
         }
      }
   },
   
   drawNav: function(oNavDiv) {
      // To overload.
   },

   drawTab: function(oBodyDiv) {
      // To overload.
   },
   
   loadTab: function(sID, sClass) {
      var sClass = IsDefined(sClass) ? sClass : "tab2BodyInner";
      // Remove existing tab.
      if (this.oVTab)
      {
         if (IsDefined(this.oVTab.oVTab))
         {
            this.oVTab.oVTab.dispose();
         }
         this.oVTab.dispose();
      }
      var oDiv = $('<div/>', 
      {
         "id": sID,
         "class": sClass
      });
      this.$('.tab2Body').append(oDiv);
      return oDiv;
   },

   onBackClick: function(e) {
      // Currently overloaded in VWearGaugeTreeActions.js
   },
   
   resizeWidth: function() {
      AVResize.prototype.resizeWidth.call(this);
      if (IsDefined(this.oVTab))
      {
         var nWidth = this.model.get("nWidth");
         var oNavDiv = this.$('.tab2Nav');
         var nNavWidth = oNavDiv.outerWidth(true);
         if (oNavDiv.css("display") == "none")
         {
            nNavWidth = 0;
         }
         var oBodyDiv = this.oVTab.$el;
         var nVTabWidth = nWidth - nNavWidth - parseInt(oBodyDiv.css('border-left-width')) - parseInt(oBodyDiv.css('border-right-width'));

         oBodyDiv.width(nVTabWidth);
         this.oVTab.model.set({
            "nWidth": nVTabWidth
         });
      }
   },
   
   resizeHeight: function() {
      AVTab1.prototype.resizeHeight.call(this);
      var nHeight = this.model.get("nHeight");
      // Resize nav.
      var nNewHeight = this.model.get("nHeight");
      var oNavDiv = this.$('.tab2Nav');
      var nBorderTop = parseInt(oNavDiv.css('border-top-width'));
      var nBorderBottom = parseInt(oNavDiv.css('border-bottom-width'));
      var nNavHeight = nHeight - nBorderTop - nBorderBottom;
      this.oVNav.model.set({
         "nHeight": nNavHeight
      });
   }
   
});