var VArraysTab = AVTreeTab.extend({
   
   drawAll: function()
   {
      var sDeviceType = GetDeviceType(this.model.get('sDeviceID'));
      var bDrawHeader = sDeviceType != "TypeSmartArrayController";
      if (bDrawHeader)
      {
         this.drawHeader();
         this.enable();
      }
      else
      {
         //this.disable();
      }
      var oBodyDiv = this.$('.opBodyInner');
      var oColumnDiv = $('<div/>', {'class':'leftColumn'});
      oBodyDiv.append(oColumnDiv);
      if (sDeviceType == "TypeSmartArrayController")
      {
         // Display overview page for Arrays.
         // If there are no arrays and no actions
         var oDevice = this.model.get('oDevice');
         var bNoArrays = false;
         var bFound = false;
         for (var i=0; !bFound && i<oDevice.length; ++i)
         {
            var oSection = oDevice[i];
            var sSectionName = oSection.SectionName;
            bFound = sSectionName == "STR_CONTROLLER_CONFIGURATION";
            if (bFound)
            {
               var oSectionLabels = oSection.SectionLabels;
               for (var j=0; j<oSectionLabels.length; ++j)
               {
                  if (oSectionLabels[j] == "ATTR_NAME_ARRAY_COUNT")
                  {
                     oSectionValues = oSection.SectionValues;
                     if (oSectionValues[j] == 0)
                     {
                        // There are no arrays available
                        var bNoArrays = true;
                     }
                  }
               }
            }
         }
         this.drawOverview(oColumnDiv);
         var nNumActions = this.drawActionWidget(oColumnDiv, true);
         if (nNumActions == 0 && bNoArrays)
         {
            this.model.set({'sOverviewMsg':"STR_NO_ACTIONS"});
            this.updateOverview();
         }
      }
      else
      {
         var sDetails = '';
         if (sDeviceType == "TypeLogicalArray")
         {
            this.drawActionWidget(oColumnDiv);
            sDetails = 'STR_ARRAY_DETAILS';
         }
         else if (sDeviceType == "TypePhysicalDrive" ||
                  sDeviceType == "TypeLogicalDrive")
         {
            this.drawActionWidget(oColumnDiv);
            if (sDeviceType == "TypePhysicalDrive")
            {
               sDetails = 'STR_PHYSICAL_DRIVE_DETAILS';
            }
            else
            {
               if (sDeviceType == "TypeLogicalDrive")
               {
                  //this.drawStatusWidget(oColumnDiv, sDetails);
               }
               sDetails = 'STR_LOGICAL_DRIVE_DETAILS';
            }
            //this.drawLeftColumn(oColumnDiv);
            //this.drawRightColumn(oColumnDiv);
         }
         this.drawDetailsWidget(oColumnDiv, sDetails);
      }
   },

   // Only allow Create Array action.
   drawActions: function(oParentDiv)
   {
      var nOperationsAdded = 0;
      var sDeviceID = this.model.get("sDeviceID");
      var sDeviceType = GetDeviceType(sDeviceID);
      var sType = this.model.get("sType"); // sType or sDeviceType? which to use? pick 1
      // TODO: Check if this is the correct type we want to send. We should send TypeArrayController?
      var oOperations = GetOperations(sDeviceType, sDeviceID).operations;
      var bIsLastAction = false;
      for (var j = 0; !bIsLastAction && j < oOperations.length; ++j)
      {
         var oList = oOperations[j].OperationList;
         for (var i = 0; !bIsLastAction && i < oList.length; ++i)
         {
            var sButtonLabel = oList[i].Label;
            var sButtonName = oList[i].Name;
            var bIsParentAction = sButtonLabel == "OPERATION_WRITE_CREATE_ARRAY";
            if (sDeviceType != "TypeSmartArrayController" || bIsParentAction)
            {
               var sDescription = oList[i].Hint;
               var bIsLastAction = (j == oOperations.length-1 && i == oList.length-1) || bIsParentAction;
               var oTabDiv = this.getActionEl(sButtonLabel, sButtonName, sDescription, bIsLastAction);
               oParentDiv.append(oTabDiv);
               ++nOperationsAdded;
            }
         }
      }
      return nOperationsAdded;
   }
   
});