var MCacheManagerNav = AMTreeNav.extend({

   initialize: function() {
      this.set({
         'sEmptyMsg':'STR_EMPTY_CACHE_MANAGER',
         "sTitle": "STR_CACHE_MANAGER"
      });
      AMTreeNav.prototype.initialize.call(this);
   },

   // TypeCacheManager
   // - TypeControllerCache (no children)
   // - TypeSmartCacheArray (0 or 1)
   //    - TypeSmartCache (for logical drive)
   //    - TypeSmartCache
   //    - ...
   getDevices: function(bFetch) {
      var sDeviceID = this.get("sDeviceID");
      //var sType = "TypeSmartCache";
      var sType = "TypeCache";
      var oChildDevices = EnumerateDevices(sType, sDeviceID, bFetch);
      // TODO following line doesn't work when enumeratedevices is cached.
      var oSortList = GetDeviceSortLists(sType, sDeviceID, bFetch);
      var oGroupDevices = EnumerateDevices("TypeSmartCacheArray", sDeviceID, bFetch);
      if (IsDefinedAndSet(oChildDevices))
      {
         oChildDevices = oChildDevices.devices;
      }
      if (IsDefinedAndSet(oGroupDevices))
      {
         oGroupDevices = oGroupDevices.devices;
      }
      var sSelectedDeviceID = this.get('sSelectedDeviceID');
      // If selected device is not in the device list, use the parent device.
      if ($.inArray(sSelectedDeviceID, oChildDevices) == -1 && 
          $.inArray(sSelectedDeviceID, oGroupDevices) == -1)
      {
         sSelectedDeviceID = sDeviceID;
      }
      var oFilter = new SALFilter(oSortList.filter);
      this.set({
         'oDevices':oChildDevices,
         'oSortList':oSortList,
         'oFilter':oFilter,
         'sSelectedDeviceID':sSelectedDeviceID
      });
      if (bFetch)
      {
         this.trigger("renderNotifyRefreshObservers");
      }
      else
      {
         this.trigger("render");
      }
   }

});