var MPhysicalDevicesNav = AMTreeNav.extend({

   initialize: function() {
      this.set({
         'sEmptyMsg':'STR_EMPTY_PHYSICAL_DEVICES',
         "sTitle": "STR_PHYSICAL_DEVICES"
      });
      AMTreeNav.prototype.initialize.call(this);
   },

   getDevices: function(bFetch) {
      var sDeviceID = this.get("sDeviceID");
      var sType = "TypePhysicalDrive";//"TypePhysicalDrive";
      var oDrives = EnumerateDevices(sType, sDeviceID, bFetch);
      // TODO following line doesn't work when enumeratedevices is cached.
      var oSortList = GetDeviceSortLists("TypePhysicalDevices", sDeviceID, bFetch);
      var oPhysicalDevices = EnumerateDevices("TypePhysicalDevices", sDeviceID, bFetch);

      if (IsDefinedAndSet(oDrives))
      {
         oDrives = oDrives.devices;
      }
      if (IsDefinedAndSet(oPhysicalDevices))
      {
         oPhysicalDevices = oPhysicalDevices.devices;
      }
      var sSelectedDeviceID = this.get('sSelectedDeviceID');
      // If selected device is not in the device list, use the parent device.
      if ($.inArray(sSelectedDeviceID, oPhysicalDevices) == -1)
      {
         sSelectedDeviceID = sDeviceID;
      }

      var oFilter = new SALFilter(oSortList.filter);
      this.set({
         'oDevices':oDrives,
         'oSortList':oSortList,
         'oFilter':oFilter,
         'sSelectedDeviceID':sSelectedDeviceID
      });
      // Draw the navigation after getting devices.
      if (bFetch)
      {
         this.trigger("renderNotifyRefreshObservers");
      }
      else
      {
         this.trigger("render");
      }
   },

   getOperations: function() {
   }

});