var VConfigurationNavDynamicSection = AVNavDynamicSection.extend({
   
   render: function() {
      AVNavDynamicSection.prototype.render.call(this);
      // Add the Selected Controller section.
      this.addSelectedControllerTabLink();
      this.addDevicesTabLinks();
      this.addToolsTabLinks();
      return this;
   },
   
   addToolsTabLinks: function() {
      var oVTabSection;
      var oTabs = [
         {
            // Cache Manager (Cache Settings, Enable HP SmartCache)
            // SmartCache for Logical Drive X
            "sIcon":"ICON_CACHE_MANAGER",
            "sName":"STR_CACHE_MANAGER",
            "sLink":"cache_manager",
            "sType":"TypeCacheManager"
         },
         {
            // License Manager (Add License Key)
            // SAAP 2.0 Feature (LK)
            // Encryption Feature (LK)
            "sIcon":"ICON_LICENSE_MANAGER",
            "sName":"STR_LICENSE_MANAGER",
            "sLink":"license_manager",
            "sType":"TypeLicenseManager"
         },
         {
            // Only for controllers that support it - P822se, some raptor controllers p2200 series
            // Encryption Manager (Enable, Change PW, Reset Keys)
            // Encryption Roles - Admin (Tasks)
            // Encryption Roles - User (Tasks)
            "sIcon":"ICON_ENCRYPTION_MANAGER",
            "sName":"STR_ENCRYPTION_MANAGER",
            "sLink":"encryption_manager",
            "sType":"TypeEncryptionManager"
         }
      ];
      var sDeviceID = this.model.get("sDeviceID");
      var oUL = this.$('#childrenUL');
      var sLinkPrefix = 'configuration/' + encodeURIComponent(sDeviceID);
      var nToolsCount = 0;
      for (var i=0; i < oTabs.length; ++i)
      {
         // Don't display count for managers.
         var nCount = 0;
         // Enumerate Devices is required to add the managers to SAL Device Map.
         var oChildren = EnumerateDevices(oTabs[i].sType, sDeviceID);
         if (IsDefined(oChildren))
         {
            nCount = oChildren.devices.length;
         }
         // Only show managers if they exist.
         if (nCount > 0)
         {
            nToolsCount++;
            // Only draw tab section if a tool exists.
            if (nToolsCount == 1)
            {
               this.drawSection("STR_TOOLS");
               oVTabSection = this.drawTabSection();
            }
            var bSelected = oTabs[i].sLink == this.model.get("sSelectedTab");
            oVTabSection.drawDeviceContainerTabLink(sLinkPrefix, sDeviceID, oTabs[i].sIcon, oTabs[i].sName, oTabs[i].sLink, oTabs[i].sType, nCount, bSelected);
         }
      }
   },
   
   addSelectedControllerTabLink: function() {
      this.drawSection("STR_SELECTED_CONTROLLER");
      var oVTabSection = this.drawTabSection();
      var oDevice = this.model.get("oDevice");
      var sDeviceID = this.model.get("sDeviceID");
      var sLink = "controller";
      var bSelected = this.model.get("sSelectedTab") == sLink;
      var sLinkPrefix = 'configuration/' + encodeURIComponent(sDeviceID);
      oVTabSection.drawConfigurationDeviceTabLink(sLinkPrefix, sDeviceID, oDevice, bSelected);
   },

   addDevicesTabLinks: function() {
      this.drawSection("STR_CONTROLLER_DEVICES");
      var oVTabSection = this.drawTabSection();
      var oTabs = [
         {
            "sIcon":"ICON_ARRAYS",
            "sName":"STR_ARRAYS",
            "sLink":"arrays",
            "sType":"TypeLogicalArray"
         },
         {
            "sIcon":"ICON_STORAGE_ENCLOSURE_EXTERNAL",
            "sName":"STR_PHYSICAL_DEVICES",
            "sLink":"physicaldevices",
            "sType":"TypePhysicalDevices"
         },
         /*{
            "sIcon":"ICON_DATA_LOGICAL_DRIVES",
            "sName":"STR_LOGICAL_DRIVES",
            "sLink":"logical_drives",
            "sType":"TypeLogicalDrive"
         },
         {
            "sIcon":"ICON_ASSIGNED_DRIVES",
            "sName":"STR_ASSIGNED_DRIVES",
            "sLink":"assigned_drives",
            "sType":"TypeAssignedDrive"
         },*/
         {
            "sIcon":"ICON_UNASSIGNED_DRIVES",
            "sName":"STR_UNASSIGNED_DRIVES",
            "sLink":"unassigned_drives",
            "sType":"TypeUnassignedDrive",
         }         
      ];
      var sDeviceID = this.model.get("sDeviceID");
      var oUL = this.$('#childrenUL');
      var sLinkPrefix = 'configuration/' + encodeURIComponent(sDeviceID);
      for (var i=0; i < oTabs.length; ++i)
      {         
         var nCount = 0;
         var oChildren = EnumerateDevices(oTabs[i].sType, sDeviceID);
         if (IsDefined(oChildren))
         {
            nCount = oChildren.devices.length;
         }
         var bSelected = oTabs[i].sLink == this.model.get("sSelectedTab");
         oVTabSection.drawDeviceContainerTabLink(sLinkPrefix, sDeviceID, oTabs[i].sIcon, oTabs[i].sName, oTabs[i].sLink, oTabs[i].sType, nCount, bSelected);
      }
   }

});