var MWearGaugeNav = AMTreeNav.extend({

   initialize: function() {
      this.set({
         'sEmptyMsg':'STR_EMPTY_SSDS',
         "sTitle": "STR_SSD_DEVICES"
      })
      AMTreeNav.prototype.initialize.call(this);
   },

   getDevices: function(bFetch) {
      //var sDeviceID = this.get("sDeviceID");
      //var sType = "TypeConfiguredDrive";
      //var oConfiguredDrives = EnumerateDevices(sType, sDeviceID, bFetch);
      // TODO following line doesn't work when enumeratedevices is cached.

      // We need to add a sort list to the wear gauge report
      // For now, create a dummy sort list based on controllers
      /*var oSortList = this.createTempSortList();

      var oArrays = EnumerateDevices("TypeLogicalArray", sDeviceID, bFetch);
      if (IsDefinedAndSet(oConfiguredDrives))
      {
         oConfiguredDrives = oConfiguredDrives.devices;
      }
      if (IsDefinedAndSet(oArrays))
      {
         oArrays = oArrays.devices;
      }
      var sSelectedDeviceID = this.get('sSelectedDeviceID');
      // If selected device is not in the device list, use the parent device.
      if ($.inArray(sSelectedDeviceID, oConfiguredDrives) == -1 && 
          $.inArray(sSelectedDeviceID, oArrays) == -1)
      {
         sSelectedDeviceID = sDeviceID;
      }*/
      var sSelectedDeviceID = this.get('sSelectedDeviceID');
      this.set({'filterDriveNumber':0});
      var oSortList = this.createTempSortList();
      var oFilter = new SALFilter(oSortList.filter);
      this.set({
         'oSortList':oSortList,
         'oFilter':oFilter//,
         //'sSelectedDeviceID':sSelectedDeviceID
      });
   },

   createTempSortList: function() {
      var oTempSortList = {};
      oTempSortList.filter = {};
      oTempSortList.filter.NAME = "STR_SHOW";
      oTempSortList.filter.FILTER_VALUES = [];
      oTempSortList.filter.FILTER_VALUES[0] = this.createFilterValues();
      return oTempSortList;
   },

   createFilterValues: function() {
      var oFilterValues = {};
      oFilterValues.NAME = "STR_ALL";
      oFilterValues.GROUPS = [];
      oFilterValues.GROUPS[0] = this.createSingleGroup();
      return oFilterValues;
   },

   createSingleGroup: function() {
      var oSingleGroup = {};
      var oControllers = this.get('oControllers');
      oSingleGroup.NAME = "STR_CONTROLLER";
      oSingleGroup.GROUP_VALUES = [];
      for (var i=0; i<oControllers.length; ++i)
      {
         oSingleGroup.GROUP_VALUES[i] = this.createControllerGroupValues(oControllers[i].id);
      }
      //oSingleGroup = this.removeEmptyControllers(oSingleGroup);
      return oSingleGroup;
   },

   createControllerGroupValues: function(sID) {
      var oControllerGroupValues = {};
      oControllerGroupValues.NAME = sID;
      oControllerGroupValues.SORT_LISTS = [];
      oControllerGroupValues.SORT_LISTS[0] = this.createSortList(sID);
      return oControllerGroupValues;
   },

   createSortList: function(sID) {
      var oSSDDevices = this.get("oSSDDevices");
      var j = this.get("filterDriveNumber");
      var oSortList = {};
      var aSortList = [];
      var k = 0;
      for (var i=0; i<oSSDDevices.length; ++i)
      {
         if (oSSDDevices[i].oController.id == sID)
         {
            aSortList[k] = j;
            ++j;
            ++k;
         }
      }
      this.set({"filterDriveNumber":j})
      oSortList.NAME = "STR_NONE";
      oSortList.SORTLIST = aSortList;
      return oSortList;
   },

   removeEmptyControllers: function(oSingleGroup) {
      var oGroupValues = oSingleGroup.GROUP_VALUES;
      var oGoodValues = [];
      for (var i=0; i<oGroupValues.length; ++i) {
         if(oGroupValues[i].SORT_LISTS[0].SORTLIST.length != 0) {
            oGoodValues.push(oGroupValues[i]);
         }
      }
      oSingleGroup.GROUP_VALUES = oGoodValues;
      return oSingleGroup;
   }

});