var VWearGaugeNav = AVTreeNav.extend({
   
   getNumDevices: function() {
      return this.model.get('oDevices').length;
   },

   drawDevices: function() {
      // Don't attempt do draw anything if there are no devices.
      if (this.getNumDevices() > 0)
      {
         var oFilter = this.model.get('oFilter');
         var oFilterGroupsDiv = this.$('.filterGroups').empty();
         var oCurrentValues = this.model.get('oAttributes');
         if (IsDefined(oCurrentValues))
         {
            oCurrentValues = oCurrentValues.CURRENT_VALUE;
            if (IsDefined(oCurrentValues))
            {
               oCurrentValues = oCurrentValues.split('|');
            }
         }
         var oDevices = this.model.get('oDevices');
         for ( var gvIndex = 0; gvIndex < oFilter.numGroupValues(); ++gvIndex )
         {
            oFilter.SelectGroupValue( gvIndex );
            oFilter.SelectSortList();
            var oSortList = oFilter.sortList();
            var sGroupName = oFilter.groupName();
            var sGroupValueName = oFilter.groupValueName();
            var sControlName = "Control Name goes here";//this.getName();
            var sGroupID = 'filterGroup' + gvIndex;
            //var oCurrentValues = this.model.get('oCurrentValues');
            var sType = this.model.get('sType');
            // Create an array with the usage remaining
            var oUsageRemaining = {};
            var oSSDStatus = {};
            var oSSDDevices = this.model.get('oSSDDevices');
            for (var i=0; i<oSSDDevices.length; ++i)
            {
               if (oSSDDevices[i].bSmartSSDSupported)
               {
                  var sID = oSSDDevices[i].oDevice.id;
                  oUsageRemaining[sID] = oSSDDevices[i].sUsageRemaining;
                  oSSDStatus[sID] = oSSDDevices[i].nSSDStatus;
               }
            }
            var oMTreeDeviceSelectorGroup = new MTreeDeviceSelectorGroup({
               'oSortList':oSortList,
               'sGroupName':sGroupName,
               'sGroupValueName':sGroupValueName,
               'sControlName':sControlName,
               'oDevices':oDevices,
               'oCurrentValues':oCurrentValues,
               'sType':sType,
               'oUsageRemaining':oUsageRemaining,
               'oSSDStatus':oSSDStatus,
               'bGroupSelectable':false
            });
            var oVTreeDeviceSelectorGroup = new VTreeDeviceSelectorGroup({
               'id':sGroupID,
               'model':oMTreeDeviceSelectorGroup
            });
            oFilterGroupsDiv.append(oVTreeDeviceSelectorGroup.$el);
         }
         // Highlight selected.
         //this.highlightChild();
      }
   },

   resizeWidth: function() {
      // Do nothing
   }
   
});