var VDiagnosticsOverview = AVActionOverview.extend({

   events: {
      "click .operation .pianoButton.action": "clickActionButton",
   },
   
   drawRightColumn: function(oParentDiv)
   {
      var oColumnDiv = $('<div/>', {'class':'rightColumn'});
      oParentDiv.append(oColumnDiv);
      
      // Error Report
      var sDeviceID = this.model.get('sDeviceID');
      this.drawErrorReportWidget(oColumnDiv, sDeviceID);
      
      // Windows Events Summary
      //this.drawWindowsEventsWidget(oColumnDiv);
   },

   drawAll: function() {
      /*var sDeviceType = GetDeviceType(this.model.get('sDeviceID'));
      var bDrawHeader = sDeviceType != "TypeSmartArrayController";
      if (bDrawHeader)
      {
         this.drawHeader();
         this.enable();
      }
      else
      {
         this.disable();
      }*/
      var oBodyDiv = this.$('.opBodyInner');
      var oColumnDiv = $('<div/>', {'class':'leftColumn'});
      oBodyDiv.append(oColumnDiv);
      if (this.model.get("sOverviewType") == "overview")
      {
         // Display overview page for Arrays.
         this.disable();
         this.drawOverview(oColumnDiv);
      }
      else
      {
         if (this.model.get("sDeviceID") == "proliant")
         {
            this.drawProliantHeader();
         }
         else
         {
            this.drawHeader();
         }
         this.drawActionWidget(oColumnDiv);
      }
   },

   drawProliantHeader: function() {
      var oOpHeaderDiv = this.$('.opHeader').empty();
      var oDeviceLabelDiv = $('<div/>', {'class': 'deviceLabel'});
      oOpHeaderDiv.append(oDeviceLabelDiv);
      var oMDeviceLabel = new MDeviceLabel({
         'sDeviceID': this.model.get('sDeviceID'),
         'sLabel': TranslateString("STR_HP_PROLIANT"),
         'sIconClass': "HPSSA_SPRITE ICON_SERVER"
      });
      var oVDeviceLabel = new VDeviceLabel({
         'model': oMDeviceLabel,
         'el': oDeviceLabelDiv
      });
      //oOpHeaderDiv.append(GetClearFloatsDiv());
   },

   drawActions: function(oParentDiv) {
      var oButtonDiv1;
      var oButtonDiv2;
      if (this.model.get("sOverviewType") == "diagnostics")
      {
         oButtonDiv1 = this.getActionEl(
            'GUI_OP_VIEW_DIAGNOSTIC_REPORT',
            'GUI_OP_VIEW_DIAGNOSTIC_REPORT',
            'GUI_OP_VIEW_DIAGNOSTIC_REPORT_HINT',
            false
         );
         oButtonDiv2 = this.getActionEl(
            'GUI_OP_SAVE_DIAGNOSTIC_REPORT',
            'GUI_OP_SAVE_DIAGNOSTIC_REPORT',
            'GUI_OP_SAVE_DIAGNOSTIC_REPORT_HINT',
            true
         );
      }
      if (this.model.get("sOverviewType") == "ssd")
      {
         oButtonDiv1 = this.getActionEl(
            'GUI_OP_VIEW_SSD_REPORT',
            'GUI_OP_VIEW_SSD_REPORT',
            'GUI_OP_VIEW_SSD_REPORT_HINT',
            false
         );
         oButtonDiv2 = this.getActionEl(
            'GUI_OP_SAVE_SSD_REPORT',
            'GUI_OP_SAVE_SSD_REPORT',
            'GUI_OP_SAVE_SSD_REPORT_HINT',
            true
         );
      }
      oParentDiv.append(oButtonDiv1);
      oParentDiv.append(oButtonDiv2);
      return 2;
   },

   clickActionButton: function(e) {
      var sActionName = e.currentTarget.id;
      var sReportType;
      var bDisplay;
      if (sActionName == "GUI_OP_VIEW_DIAGNOSTIC_REPORT")
      {
         sReportType = "ADU";
         bDisplay = true;
      }
      else if (sActionName == "GUI_OP_VIEW_SSD_REPORT")
      {
         sReportType = "SSD";
         bDisplay = true;
      }
      else if (sActionName == "GUI_OP_SAVE_DIAGNOSTIC_REPORT")
      {
         sReportType = "ADU";
         bDisplay = false;
      }
      else if (sActionName == "GUI_OP_SAVE_SSD_REPORT")
      {
         sReportType = "SSD";
         bDisplay = false;
      }
      var oMDiagsPopup = new MDiagsPopup ({
         'sDeviceID': this.model.get("sDeviceID"),
         'sReportType': sReportType,
         'bDisplay': bDisplay
      });
      var oVDiagsPopup = new VDiagsPopup ({
         'model': oMDiagsPopup
      }) ;
      this.$el.trigger("popup", {
         'sType': 'diagsPopup',
         'oVContent': oVDiagsPopup
      });

      return false;
   },

   disable: function()
   {
      this.$('.opBody').addClass("disabled");
      this.$('.leftColumn').addClass("singleColumn");
      this.$('.singleColumn').removeClass("leftColumn");
   },

   enable: function()
   {
      this.$('.opBody').removeClass("disabled");
      this.$('.singleColumn').addClass("leftColumn");
      this.$('.leftColumn').removeClass("singleColumn");
   },

   drawOverview: function(oParentDiv)
   {
      var oTitle = $('<div/>', {'class': 'overview'});
      oTitle.html(TranslateString("STR_SELECT_A_REPORT_TYPE_ON_LEFT"));
      oParentDiv.append(oTitle);
   },

   drawErrorReportWidget: function(oParentDiv, sDeviceID)
   {
      var oWidgetDiv = this.drawColumnWidget(oParentDiv, "errorReportWidget");
      var oBox = this.drawBox(oWidgetDiv);
      
      var sDeviceID = this.model.get("sDeviceID");
      var oOperationSelectionDiv = $('<div/>', { 'class': "errorReportDiv" });
      var oTitle = $('<div/>', {'class': 'title'});
      oTitle.html(TranslateString("STR_ERROR_REPORT"));
      oBox.append(oTitle);
      oBox.append(oOperationSelectionDiv);
      var oErrorReport = GetErrorReport(sDeviceID);
   }

});