var VControllerOverview = AVActionOverview.extend({
   
   drawRightColumn: function(oParentDiv)
   {
      var oColumnDiv = $('<div/>', {'class':'rightColumn'});
      oParentDiv.append(oColumnDiv);
      
      // Status
      this.drawStatusWidget(oColumnDiv);
      
      // Configuration Summary
      this.drawConfigWidget(oColumnDiv);
   },
   
   drawActions: function(oParentDiv)
   {
      var sDeviceID = this.model.get("sDeviceID");
      var oAllowedTasks = EnumerateAllowedDeviceTasks(sDeviceID).RequestResult;
      var sLinkPath = "#home/arraycontroller/" + encodeURIComponent(sDeviceID) + "/";
      var oActions = [];
      for (var j=0; j<oAllowedTasks.length; ++j) {
         var sTask = oAllowedTasks[j];
         if (sTask == "SALTaskConfiguration") {
            oActions.push({
               'sLink':'#configuration/' + encodeURIComponent(sDeviceID),
               'sLabel':'GUI_OP_CONFIGURE_CONTROLLER',
               'sHint':'GUI_OP_CONFIGURE_CONTROLLER_HINT'
            });
         }
         else if (sTask == "SALTaskDiagnostics") {
             oActions.push({
               'sLink':"#diagnostics/" + encodeURIComponent(sDeviceID),
               'sLabel':'GUI_OP_DIAGNOSE_CONTROLLER',
               'sHint':'GUI_OP_DIAGNOSE_CONTROLLER_HINT'
            });
         }
      }
      /*var oActions = [
         // Configure
         {
            'sLink':'#configuration/' + sDeviceID,
            'sLabel':'GUI_OP_CONFIGURE_CONTROLLER',
            'sHint':'GUI_OP_CONFIGURE_CONTROLLER_HINT'
         },
         // Maintain
         {
            'sLink':'#configuration/' + sDeviceID,
            'sLabel':'GUI_OP_MAINTAIN_CONTROLLER',
            'sHint':'GUI_OP_MAINTAIN_CONTROLLER_HINT'
         },
         // Analyze Performance
         {
            'sLink':'#configuration/' + sDeviceID,
            'sLabel':'GUI_OP_ANALYZE_CONTROLLER',
            'sHint':'GUI_OP_ANALYZE_CONTROLLER_HINT'
         },
         // Diagnose
         {
            'sLink':"#diagnostics/" + sDeviceID,
            'sLabel':'GUI_OP_DIAGNOSE_CONTROLLER',
            'sHint':'GUI_OP_DIAGNOSE_CONTROLLER_HINT'
         }
      ];*/
      this.addNavButtons(oActions, oParentDiv);
      return oActions.length;
   }
});