var VHomeNavDynamicSection = AVNavDynamicSection.extend({

   render: function() {
      AVNavDynamicSection.prototype.render.call(this);
      this.drawSection("STR_SERVER");
      this.addServerTabLink();
      this.drawSection("STR_ARRAY_CONTROLLERS");
      this.addControllerTabLinks();
   },
   
   addServerTabLink: function() {
      var oVTabSection = this.drawTabSection();
      var sDeviceID = "proliant";
      var bSelected = this.model.get("sSelectedTab") == sDeviceID;
      var sLinkPrefix = "home/server/" + sDeviceID;
      oVTabSection.drawServerTabLink(sLinkPrefix, sDeviceID, bSelected);
   },
   
   addControllerTabLinks: function() {
      var oVTabSection = this.drawTabSection();
      var oControllerList = this.model.get('oControllerList');
      for (var i=0; i<oControllerList.length; ++i)
      {
         var sDeviceID = oControllerList[i];
         var sLinkPrefix = "home/arraycontroller/" + encodeURIComponent(sDeviceID);
         var bSelected = this.model.get("sSelectedTab") == sDeviceID;
         oVTabSection.drawConfigurationDeviceTabLink(sLinkPrefix, sDeviceID, null, bSelected);
      }
      // Add no controller found message if applicable.
      if (oControllerList.length == 0)
      {
         oVTabSection.addNote("STR_MSG_NO_CTRLS_DETECTED_SHORT");
      }
   }

});