// Main entry point.
// $(callback); is a shortcut for $(document).ready(callback));
$(function(){

   if (typeof(String.prototype.trim) !== 'function')
   {
      String.prototype.trim = function()
      {
         return this.replace(/^\s+|\s+$/g, ''); 
      }
   }

   var oWin = $(window);
   
   g_oStringMap = GetStringMap();
   
   g_oGlobals = GetVariables();
   
   // JavaScript Smart Storage Administrator Router.
   g_oRSSA = new RSmartStorageAdministrator();   
   
   // JavaScript Smart Storage Administrator Model.
   g_oMSSA = new MSmartStorageAdministrator();
   
   var oBody = $('body');
   var oAppContainer = $('#appContainer');
   var nAppMinWidth = parseInt(oAppContainer.css("min-width"));
   var nAppMinHeight = parseInt(oAppContainer.css("min-height"));
   oWin.bind('resize', function()
   {
      var nW = oWin.width();
      var nH = oWin.height();
      var bUnderMinWidth = nW < nAppMinWidth;
      var bUnderMinHeight = nH < nAppMinHeight;
      var bShowBodyScrollbars = bUnderMinWidth || bUnderMinHeight;
      if (bShowBodyScrollbars == true)
      {
         oBody.css({'overflow': 'auto'});
      }
      else
      {
         oBody.css({'overflow': 'hidden'});
      }
      // Update dimensions again since scrollbars may have adjusted lengths.
      nW = bUnderMinWidth ? nAppMinWidth : oWin.width();
      nH = bUnderMinHeight ? nAppMinHeight : oWin.height();
      var oAppContainer = $('#appContainer');
      oAppContainer.css(
         {
            'width': nW,
            'height': nH
         }
      );
      g_oMSSA.set({nWidth: nW, nHeight: nH});
   });

   // JavaScript Smart Storage Administrator View.
   var oVSSA = new VSmartStorageAdministrator({'el': oAppContainer, 'model': g_oMSSA});
   
   // Register Keyboard Event Handler
   oBody.keydown(function(e) {
      var sKey = e.which;
      // Global, application-wide keyboard shortcuts:
      switch(sKey)
      {
         case 116: // F5 - Rescan and Reset Application
            if (!oVSSA.clickRescan())
            {
               e.preventDefault();
            }
            break;
         default:
            var o = $(e.target);
            var sClassName = e.target.className;
            // Do not execute shortcut keys in help search box of while an action is being executed.
            if (sClassName.indexOf("helpSearchBox") == -1)
            {
               if (!g_bActionInProgress)
               {
                  switch(sKey)
                  {
                     case 13: // ENTER - simulate click default
                        // Don't simulate if ENTER was pressed on a non text input with class popupTabbable.
                        var bHasPopupTabbable = sClassName.indexOf("popupTabbable") != -1;
                        var sAttrType = o.attr("type");
                        var bIsTextInput = o.is("input") && 
                           (sAttrType == "text" || 
                            sAttrType == "radio" ||
                            sAttrType == "password");
                        if (!bHasPopupTabbable || bIsTextInput)
                        {
                           oVSSA.onDefault();
                        }
                        break;
                     default:
                        if (sClassName.indexOf("textInput") == -1 && 
                            sClassName.indexOf("passwordInput") == -1 && 
                            sClassName.indexOf("setPasswordInput") == -1)
                        {
                           switch(sKey)
                           {
                           /*
                           case 68: // d - delete localStorage data
                              localStorage.clear();
                              break;
                           case 69: // e
                              g_oStringMap = GetStringMap("en");
                              UpdateLanguage("en");
                              //Backbone.history.loadUrl(Backbone.history.fragment);
                              break;*/
                           case 27: // ESC - dismiss (popup cancel)
                              oVSSA.onDismissPopup();
                              break;
                           case 66: // b - browse - toggle main menu
                              oVSSA.clickMainMenu();
                              break;
                           case 72: // h - help
                              oVSSA.clickHelp();
                              break;
                           case 82: // r - refresh
                              return oVSSA.clickRefresh();
                              break;
                           case 88: // x - exit application
                              oVSSA.clickExit();
                              break;
                           default:
                           }
                        }
                  }
               }
               else
               {
                  switch(sKey)
                  {
                  case 27: // ESC - prevent default ESC key action when action is in progress.
                     return false;
                     break;
                  }
               }
            }
      }
   });
});