function SALFilter( filter )
{
   this.m_Filter = filter;
   this.m_selectedFilterValueIndex = 0;
   this.m_selectedFilterValue = null;
   this.m_selectedGroupIndex = 0;
   this.m_selectedGroup = null;
   this.m_selectedGroupValueIndex = 0;
   this.m_selectedGroupValue = null;
   this.m_selectedSortListIndex = 0;
   this.m_selectedSortList = null;
}
SALFilter.prototype.isValidFilter = function()
{
   return this.m_Filter.FILTER_VALUES.length > 0;
}
SALFilter.prototype.filterName = function()
{
   return this.m_Filter.NAME;
}
SALFilter.prototype.numFilterValues = function()
{
   return this.m_Filter.FILTER_VALUES.length;
}
SALFilter.prototype.SelectFilterValue = function( filterValueIndex )
{
   this.m_selectedFilterValueIndex = filterValueIndex;
   this.m_selectedFilterValue = this.m_Filter.FILTER_VALUES[ filterValueIndex ];
}
SALFilter.prototype.filterValueName = function()
{
   return this.m_selectedFilterValue.NAME;
}
SALFilter.prototype.numGroups = function()
{
   var nLength = 0;
   if (IsDefined(this.m_selectedFilterValue))
   {
      var oGroups = this.m_selectedFilterValue.GROUPS;
      if (IsDefined(oGroups))
      {
         nLength = oGroups.length;
      }
   }
   return nLength;
}
SALFilter.prototype.matchGroup = function( groupName )
{
   var nMatchedIndex = 0;
   var oGroups = this.m_selectedFilterValue.GROUPS;
   for (var i=0; i<oGroups.length; ++i)
   {
      if (oGroups[i].NAME == groupName)
      {
         nMatchedIndex = i;
      }
   }
   return nMatchedIndex;
}
SALFilter.prototype.SelectGroup = function( groupIndex )
{
   this.m_selectedGroupIndex = groupIndex;
   this.m_selectedGroup = this.m_selectedFilterValue.GROUPS[ groupIndex ];
}
SALFilter.prototype.groupName = function()
{
   return this.m_selectedGroup.NAME;
}
SALFilter.prototype.numGroupValues = function()
{
   return this.m_selectedGroup.GROUP_VALUES.length;
}
SALFilter.prototype.SelectGroupValue = function( groupValueIndex )
{
   this.m_selectedGroupValueIndex = groupValueIndex;
   this.m_selectedGroupValue = this.m_selectedGroup.GROUP_VALUES[groupValueIndex];
}
SALFilter.prototype.groupValueName = function()
{
   return this.m_selectedGroupValue.NAME;
}
SALFilter.prototype.numSortLists = function()
{
   return this.m_selectedGroupValue.SORT_LISTS.length;
}
SALFilter.prototype.matchSortList = function( sortListName )
{
   var nMatchedIndex = 0;
   var oSortLists = this.m_selectedGroupValue.SORT_LISTS;
   for (var i=0; i<oSortLists.length; ++i)
   {
      if (oSortLists[i].NAME == sortListName)
      {
         nMatchedIndex = i;
      }
   }
   return nMatchedIndex;
}
SALFilter.prototype.SelectSortList = function( sortListIndex )
{
   if ( sortListIndex != null )
   {
      this.m_selectedSortListIndex = sortListIndex;
   }
   this.m_selectedSortList = this.m_selectedGroupValue.SORT_LISTS[this.m_selectedSortListIndex];
}
SALFilter.prototype.sortListName = function()
{
   return this.m_selectedSortList.NAME;
}
SALFilter.prototype.sortList = function()
{
   return this.m_selectedSortList.SORTLIST;
}