var VControlEnableCheckbox = AVControl.extend({

   events: {
      "change input[type=EnableCheckbox]" : "EnableCheckboxChanged"
   },
   
   initialize: function() {
      AVControl.prototype.initialize.call(this);
   },
   
   render: function() {
      var oEnableCheckboxDiv = $('<div/>', {'class': "enableCheckboxWrapper"});
      $(this.el).append(oEnableCheckboxDiv);
      this.drawEnableCheckbox();
      return this;
   },
   
   getValue: function() {
      var s = '';
      s = this.$('input[name=' + this.model.get("sName") + ']:checked').val();
      if (s == true)
      {
         s = this.model.get('true');
      }
      else
      {
         s = this.model.get('false');
      }
      return s;
   },
   
   drawEnableCheckbox: function() {
      var oEnableCheckboxDiv = this.$('.enableCheckboxWrapper');
      var oValues = this.model.get("oValues");
      var oAttributes = this.model.get("oAttributes");
      var sCurrentValue = oAttributes.CURRENT_VALUE;
      var sDefaultValue = oAttributes.DEFAULT_VALUE;
      if (!IsDefined(sCurrentValue))
      {
         sCurrentValue = sDefaultValue;
      }
      var bEnabled = true;
      if (sCurrentValue.indexOf("DISABLED") >= 0 ||
          sCurrentValue.indexOf("FALSE") >= 0)
      {
         bEnabled = false;
      }
      var hasCurrentValue = IsDefined(sCurrentValue);
      var sName = this.model.get("sName");
      var oEnableCheckboxInputDiv = $('<div/>', {'class': "enableCheckboxInputWrapper"});
      var sID = sName;
      var oEnableCheckboxInput = $('<input/>', 
      {
         'id': sID,
         'class': "enableCheckboxInput popupTabbable",
         'type': "checkbox",
         'name': sName,
         'value': true
      });
      var oEnableCheckboxInputLabel = $('<label/>',
      {
         'for': sID,
         'class': "enableCheckboxInputLabel"
      });
      oEnableCheckboxInputLabel.html(TranslateString("STR_ENABLED"));
      oEnableCheckboxInputDiv.append(oEnableCheckboxInput);
      oEnableCheckboxInputDiv.append(oEnableCheckboxInputLabel);
      oEnableCheckboxDiv.append(oEnableCheckboxInputDiv);
      if (bEnabled == true)
      {
         oEnableCheckboxInput.prop("checked", true);
      }
      this.model.set({
         'true': oValues[0],
         'false': oValues[1]
      });
   },
   
   EnableCheckboxChanged: function(e) {
      this.model.set({
         'sValue': this.$('input[name=' + this.model.get("sName") + ']:checked').val()
      });
   }
});