var VControlTextBox = AVControl.extend({

   events: {

   },
   
   initialize: function() {
      AVControl.prototype.initialize.call(this);
   },
   
   render: function() {
      var textBoxDiv = $('<div/>', {'class': "textBoxWrapper"});
      $(this.el).append(textBoxDiv);
      this.drawtextBox();
      return this;
   },
   
   getValue: function() {
      var s = '';
      s = this.$('input[id=textBox]').val();
      // For Master Key, encode all characters
      var sName = this.model.get("sName");
      if (sName == "ATTR_NAME_KEK_NAME")
      {
         s = encodeURIComponent(s);
      }
      return s;
   },

   isValid: function() {
      var errorMessage = this.validateText();
      if (errorMessage != "")
      {
         errorMessage = TranslateString(this.model.get("sName")) + ": " + TranslateString(errorMessage);
      }
      return errorMessage;
   },
   
   drawtextBox: function() {
      var textBoxDiv = this.$('.textBoxWrapper');
      var oAttributes = this.model.get("oAttributes");
      var sOptional = this.model.get("sOptional");
      var nMaxValue = parseInt(oAttributes.MAXIMUM_VALUE);
      var nMinValue = parseInt(oAttributes.MINIMUM_VALUE);
      var sName = this.model.get("sName");
      var textBoxLabel = $('<div/>', {'class': "textBoxLabel"});
      textBoxLabel.html(TranslateString("STR_ENTER_PASSWORD") + "<br/>");
      var textBox = $('<input/>',
      {
         'id': "textBox",
         'class': "textInput popupTabbable",
         'type': "text",
         'name': sName,
         'value': "",
         'width': "200px",
         'minlength': nMinValue,
         'maxlength': nMaxValue
      });
      var textBoxErrorLabel = $('<label/>',
      {
         'for': "textBox",
         'class': "infoBox"
      });
      // We allow pasting for Master Key now (KEK_NAME)
      /*if (sName == "ATTR_NAME_KEK_NAME")
      {  
         // Disable pasting.
         textBox.on("paste", PreventDefault);
      }*/
      textBoxDiv.append(textBox);
      textBoxDiv.append(textBoxErrorLabel);
   },

   validateText: function() {
      var errorMessage = "";
      var oTextBox = this.$('input[id=textBox]');
      var s1 = oTextBox.val();
      var nMin = oTextBox.attr('minlength');
      var nMax = oTextBox.attr('maxlength');
      // check if control is optional
      if (this.model.get('sOptional') == "FALSE" || s1 != "") {
         var oAttributes = this.model.get("oAttributes");
         var sAscii = oAttributes.ASCII_ONLY;

         if (s1.length == 0)
         {
            errorMessage = "STR_ERROR_TEXT_MISSING|" + this.model.get("sName");
         }
         else if (s1.length < nMin)
         {
            errorMessage = "STR_ERROR_MINLENGTH|" + nMin;
         }
         else if (s1.length > nMax)
         {
            errorMessage = "STR_ERROR_MAXLENGTH|" + nMax;
         }
         else if (s1.trim() == "")
         {
            errorMessage = "STR_ERROR_SPACES_ONLY|" + this.model.get("sName");
         }
         else if(sAscii == "TRUE")
         {
            for(var i=0; i<s1.length; i++)
            {
              if(s1.charCodeAt(i) < 32 || s1.charCodeAt(i) > 126)
              {
                  errorMessage = "STR_ERROR_ASCII_ONLY|" + this.model.get("sName");
                  break;
              }
            }
         }

         if (errorMessage != "")
         {
            this.$('.infoBox').css("display", "inline");
            this.$('.infoBox').html(TranslateString(errorMessage));
         }
         else
         {
            // Reset the infoBox so that it will not retain the previous error message.
            this.$('.infoBox').css("display", "none");
         }

      }

      return errorMessage;
   }

});