var VControlTextBoxWithPrompt = AVControl.extend({

   events: {

   },
   
   initialize: function() {
      AVControl.prototype.initialize.call(this);
   },
   
   render: function() {
      var textBoxDiv = $('<div/>', {'class': "textBoxWrapper"});
      $(this.el).append(textBoxDiv);
      this.drawtextBox();
      return this;
   },
   
   getValue: function() {
      var s = '';
      s = this.$('input[id=textBox]').val();
      return s;
   },

   isValid: function() {
      var errorMessage = this.validateText();
      if (errorMessage != "")
      {
         errorMessage = TranslateString(this.model.get("sName")) + ": " + TranslateString(errorMessage);
      }
      return errorMessage;
   },
   
   drawtextBox: function() {
      var textBoxDiv = this.$('.textBoxWrapper');
      var oAttributes = this.model.get("oAttributes");
      var nMaxValue = parseInt(oAttributes.MAXIMUM_VALUE);
      var nMinValue = parseInt(oAttributes.MINIMUM_VALUE);
      var sHint = decodeURIComponent(oAttributes.Hint);
      var sName = this.model.get("sName");
      var textBoxLabel = $('<div/>', {'class': "textBoxLabel"});
      textBoxLabel.html(TranslateString("STR_FORGOT_PASSWORD_QUESTION") + sHint);
      var textBox = $('<input/>',
      {
         'id': "textBox",
         'class': "textInput popupTabbable",
         'type': "text",
         'name': sName,
         'value': "",
         'width': "200px",
         'minlength': nMinValue,
         'maxlength': nMaxValue
      });
      var textBoxErrorLabel = $('<label/>',
      {
         'for': "textBox",
         'class': "infoBox"
      });
      textBoxDiv.append(textBoxLabel);
      textBoxDiv.append(textBox);
      textBoxDiv.append(textBoxErrorLabel);
   },

   validateText: function() {
      var errorMessage = "";
      var oTextBox = this.$('input[id=textBox]');
      var s1 = oTextBox.val();
      var nMin = oTextBox.attr('minlength');
      var nMax = oTextBox.attr('maxlength');
      if (s1.length == 0)
      {
         errorMessage = "STR_ERROR_TEXT_MISSING|" + this.model.get("sName");
      }
      else if (s1.length < nMin)
      {
         errorMessage = "STR_ERROR_MINLENGTH|" + nMin;
      }
      else if (s1.length > nMax)
      {
         errorMessage = "STR_ERROR_MAXLENGTH|" + nMax;
      }
      if (errorMessage != "")
      {
         this.$('.infoBox').css("display", "inline");
         this.$('.infoBox').html(TranslateString(errorMessage));
      }
      return errorMessage;
   }

});