// A collapsable note section for Action and Action Response pages.
// Defaults to being expanded.
var VCollapsedNote = AVResize.extend({
   
   className: "SSANote collapsedNote",
   
   events: {
      //"click div.leftArrow" : "previousNote",
      //"click div.rightArrow" : "nextNote",
      //"click div.noteNumberTwo" : "toggleAllNotes",
      //"click div.expandNote" : "toggleNote"
   },
   
   initialize: function() {
      AVResize.prototype.initialize.call(this);
      this.render();
   },

   render: function() {  
      // Get all notes
      var oNotes = this.model.get("oNotes");
      var nDisplay = parseInt(this.model.get("nDisplay"));
      var oTable = $('<table/>', {'class':'noteTable'});
      // Notes start collapsed; only need the first note.
      // nDisplay is initialized to 0
      var sType = oNotes[nDisplay].NoteType;
      this.$el.addClass(sType);
      this.$el.append(oTable);
      this.drawNotes();
      
      /*
      var bNav = false;
      var oNoteTR = $('<tr/>', {'id':'tableRow'});
      var oIconDiv = $('<div/>', {'class':'icon HPSSA_SPRITE'});
      var oMessageDiv = $('<div/>', {'class':'notes message'});
      
      var oMessage = oNotes[nDisplay].NoteContent;
      var sMessage = "";
      for (var i = 0; i<oMessage.length; ++i)
      {
         sMessage += TranslateString(oMessage[i]);
      }
      oMessageDiv.html(sMessage);
      // Create a space for the expand button
      var oExpandDiv = $('<div/>', {'class':'expandNote'});
      oExpandDiv.html(TranslateString("STR_EXPAND_NOTE"));
      var oIconTD = $('<td/>',{'class':'one'});
      var oMessageTD = $('<td/>',{'class':'two'});
      var oExpandTD = $('<td/>', {'class':'three','rowspan':oNotes.length});
      oIconTD.append(oIconDiv);
      oMessageTD.append(oMessageDiv);
      oExpandTD.append(oExpandDiv);
      oNoteTR.append(oIconTD);
      oNoteTR.append(oMessageTD);
      oNoteTR.append(oExpandTD);
      oTable.append(oNoteTR);*/
      return this;
   },

   drawNotes: function() {
      var oNotes = this.model.get("oNotes");
      var oTable = this.$('table');
      oTable.empty();
      oTable.css('border','2');
      // Show all the notes
      for (var i = 0; i < oNotes.length; ++i)
      {
         var sType = oNotes[i].NoteType;
         this.$el.addClass(sType);
         var sNoteClass = sType;
         var oNoteTR = $('<tr/>', {'class':sNoteClass});
         oTable.append(oNoteTR);

         var oConfMsgsDiv = $('<div/>', {'class':'message'});
         var oConfMsgDiv = $('<div/>', {'class': 'confMsg'});
         var oNoteContent = oNotes[i].NoteContent;
         var j = 0;
         var nNoteContentLength = oNoteContent.length;
         while (j < nNoteContentLength)
         {
            var sEntryClass = 'confMsgEntry';
            // No bottom margin for last entry.
            if (j == nNoteContentLength-1 && i == oNotes.length-1)// && sType == "CONFIRMNOTE")
            {
               sEntryClass += ' last';
            }
            var oConfMsgEntryDiv = $('<div/>', {'class': sEntryClass});
            var sNoteContent = oNoteContent[j];
            if (sNoteContent == "HTML_BEGIN_UL")
            {
               var oUL = $('<ul/>');
               oConfMsgEntryDiv.append(oUL);
               var bEndFound = false;
               for (j=j+1; j < nNoteContentLength && !bEndFound; ++j)
               {
                  bEndFound = oNoteContent[j] == "HTML_END_UL";
                  if (!bEndFound)
                  {
                     var oLI = $('<li/>');
                     oLI.append(TranslateString(oNoteContent[j]));
                     oUL.append(oLI);
                  }
               }
            }
            else
            {
               oConfMsgEntryDiv.append(TranslateString(sNoteContent));
               ++j;
            }

            oConfMsgDiv.append(oConfMsgEntryDiv);
         }
         oConfMsgsDiv.append(oConfMsgDiv);
         // Add Icon
         var oIconTD = $('<td/>',{'class':'one'});
         // Don't draw warning icon for confirm question unless it's the
         // only message displayed (first message).
         if (sType != "CONFIRMNOTE" || (sType == "CONFIRMNOTE" && i == 0))
         {
            var oIconDiv = $('<div/>', {'class':'icon HPSSA_SPRITE'});
            oIconTD.append(oIconDiv);
         }
         oNoteTR.append(oIconTD);
         // Add Message
         var oMessageTD = $('<td/>',{'class':'two'});
         oMessageTD.append(oConfMsgsDiv);
         oNoteTR.append(oMessageTD);
         // Add expand/contract control
         var oControlTD = $('<td/>', {'class':'three'});
         oNoteTR.append(oControlTD);
         // Draw control in first row.
         var nNoteCount = oNotes.length;
         if (i==0 && nNoteCount > 1)
         {
            var oControlDiv = $('<a/>', {
               'href': '',
               'class': 'toggleControl popupTabbable'
            });
            oControlDiv.append(TranslateString("STR_HIDE"));
            this.model.set({'bExpanded':true});
            var oThis = this;
            oControlDiv.click(function() {
               if (oThis.model.get('bExpanded'))
               {
                  oThis.model.set({'bExpanded':false});
                  oThis.$('.collapsable').hide();
                  oThis.$('.toggleControl').html(TranslateString("STR_SHOW_ALL|"+nNoteCount));
               }
               else
               {
                  oThis.model.set({'bExpanded':true});
                  oThis.$('.collapsable').show();
                  oThis.$('.toggleControl').html(TranslateString("STR_HIDE"));
               }
               oThis.triggerResize();
               return false;
            });
            oControlTD.append(oControlDiv);
         }
         else
         {
            oNoteTR.addClass("collapsable")
         }
      }
      this.model.set({'bShowAll':true});
   },

   /*
   createNavTD: function()
   {
      var nDisplay = this.model.get('nDisplay');
      var oNotes = this.model.get('oNotes');
      var oNavTD = $('<td/>', {'class':'zero','rowspan':oNotes.length});
      //var oNavTDSpan = $('<div/>', {'class':'zeroSpan'});
      var oNavDiv = $('<div/>', {'class':'collapsedNoteHeader'});
      var oNoteNavDiv = $('<div/>', {'class':'noteNavigation'});
      var oLeftArrowDiv = $('<div/>', {'class':'leftArrow HPSSA_SPRITE'});
      var oRightArrowDiv = $('<div/>', {'class':'rightArrow HPSSA_SPRITE'});
      var oNoteNumberOneDiv = $('<div/>', {'class':'noteNumberOne'});
      var oNoteNumberTwoDiv = $('<div/>', {'class':'noteNumberTwo'});
      var sNoteNumberOne = "STR_NOTE_NUMBER_ONE" + "|" + parseInt(nDisplay+1);
      var sNoteNumberTwo = "STR_NOTE_NUMBER_TWO" + "|" + parseInt(oNotes.length);
      oNoteNumberOneDiv.html(TranslateString(sNoteNumberOne));
      oNoteNumberTwoDiv.html(TranslateString(sNoteNumberTwo));
      //var oViewAllDiv = $('<div/>', {'class':'allNotes'});
      //oViewAllDiv.html(TranslateString("STR_VIEW_ALL"));
      oNoteNavDiv.append(oLeftArrowDiv);
      oNoteNavDiv.append(oNoteNumberOneDiv);
      oNoteNavDiv.append(oNoteNumberTwoDiv);
      oNoteNavDiv.append(oRightArrowDiv);
      oNavDiv.append(oNoteNavDiv);
      //oNavDiv.append(oViewAllDiv);
      //this.$el.append(oNavDiv);
      //this.$el.append(GetClearFloatsDiv());
      oNavDiv.append(GetClearFloatsDiv());
      //oNavTDSpan.append(oNavDiv);
      //oNavTD.append(oNavTDSpan);
      oNavTD.append(oNavDiv);
      return oNavTD;
   },
   previousNote: function()
   {
      // Show the previous note if you are not displaying the first note
      if (!this.model.get('bShowAll'))
      {
         var oNotes = this.model.get("oNotes");
         var nDisplay = parseInt(this.model.get("nDisplay"));
         if (nDisplay != 0)
         {
            nDisplay = --nDisplay;
            this.model.set({'nDisplay':nDisplay});
            this.refreshNote();
         }
      }
   },
   
   nextNote: function()
   {
      // Show the next note if you are not displaying the last note
      if (!this.model.get('bShowAll'))
      {
         var oNotes = this.model.get("oNotes");
         var nDisplay = parseInt(this.model.get("nDisplay"));
         if (nDisplay != oNotes.length - 1)
         {
            nDisplay = ++nDisplay;
            this.model.set({'nDisplay':nDisplay});
            this.refreshNote();
         }
      }
   },
   
   refreshNoteNumber: function(nDisplay,oNotes)
   {
      // Refresh the "x of x Alerts" text
      var sNoteNumberOne = "STR_NOTE_NUMBER_ONE" + "|" + parseInt(nDisplay+1);
      var sNoteNumberTwo = "STR_NOTE_NUMBER_TWO" + "|" + parseInt(oNotes.length);
      this.$('.noteNumberOne').html(TranslateString(sNoteNumberOne));
      this.$('.noteNumberTwo').html(TranslateString(sNoteNumberTwo));
   },
   
   
   refreshNote: function()
   {
      // Display the entire note, then truncate if needed.
      var oNotes = this.model.get("oNotes");
      var nDisplay = parseInt(this.model.get("nDisplay"));
      var oMessage = oNotes[nDisplay].NoteContent;
      var sMessage = "";
      for (var i = 0; i<oMessage.length; ++i)
      {
         sMessage += TranslateString(oMessage[i]);
      }
      this.$('.message').html(sMessage);
      // If we can display the message without truncating, remove the "More/Less" option/
      if (!this.model.get('bExpanded'))
      {
         // Test to see if you truncate without the "more/less" button
         this.$('.message').widthTruncate();
         if (this.$('.didNotTruncate').length != 0)
         {
            this.showExpand(false);
         }
         else
         {
            this.showExpand(true);
            this.$('.message').widthTruncate();
            this.$('.expandNote').html(TranslateString("STR_EXPAND_NOTE"));
            this.model.set({'bExpanded':false});
         }
      }
      else
      {
         this.$('.expandNote').html(TranslateString("STR_COLLAPSE_NOTE"));
         this.model.set({'bExpanded':true});
      }
      this.refreshNoteNumber(nDisplay,oNotes);
   },
   
   showExpand: function(bShow)
   {
      var oExpandTD = this.$('td.three');
      var oNotes = this.model.get('oNotes');
      if (bShow)
      {
         if (oExpandTD.length == 0)
         {
            var oExpandTD = $('<td/>', {'class':'three','rowspan':oNotes.length});
            var oExpandDiv = $('<div/>', {'class':'expandNote'});
            oExpandDiv.html(TranslateString("STR_EXPAND_NOTE"));
            oExpandTD.append(oExpandDiv);
            this.$('#tableRow').append(oExpandTD);
         }
      }
      else
      {
         if (IsDefined(oExpandTD))
         {
            oExpandTD.remove();
         }
      }
   },
   
   toggleNote: function()
   {
      if (this.model.get('bExpanded'))
      {
         this.model.set({'bExpanded':false});
      }
      else
      {
         this.model.set({'bExpanded':true});
      }
      this.refreshNote();
      this.triggerResize();
   },
   
   toggleAllNotes: function()
   {
      var oTable = this.$('table');
      oTable.empty();
      oTable.css('border','2');
      var oNotes = this.model.get("oNotes");
      var nDisplay = this.model.get("nDisplay");
      // If you are toggling all notes, there is always more than one note
      // There will always be a note navigation column
      var oNavTD = this.createNavTD();
      var oNavTR = $('<tr/>', {'id':'tableRow'});
      oNavTR.append(oNavTD);
      oTable.append(oNavTR);
      // Show all the notes
      if (!this.model.get('bShowAll'))
      {
         for (var i = 0; i < oNotes.length; ++i)
         {
            var oNoteTR = $('<tr/>');
            var oIconDiv = $('<div/>', {'class':'icon HPSSA_SPRITE'});
            var oMessageDiv = $('<div/>', {'class':'message'});
            var sType = oNotes[i].NoteType;
            this.$el.addClass(sType);
            var oMessage = oNotes[i].NoteContent;
            var sMessage = "";
            for (var j = 0; j<oMessage.length; ++j)
            {
               sMessage += TranslateString(oMessage[j]);
            }
            oMessageDiv.html(sMessage);
            var oIconTD = $('<td/>',{'class':'one'});
            var oMessageTD = $('<td/>',{'class':'two'});
            oIconTD.append(oIconDiv);
            oMessageTD.append(oMessageDiv);
            if (i == 0)
            {
               oNavTR.append(oIconTD);
               oNavTR.append(oMessageTD);
               oTable.append(oNavTR);
            }
            else
            {
               oNoteTR.append(oIconTD);
               oNoteTR.append(oMessageTD);
               oTable.append(oNoteTR);
            }
         }
         this.model.set({'bShowAll':true});
      }
      // Show only one note
      else
      {         
         var oIconDiv = $('<div/>', {'class':'icon HPSSA_SPRITE'});
         var oMessageDiv = $('<div/>', {'class':'message'});
         var sType = oNotes[nDisplay].NoteType;
         this.$el.addClass(sType);
         var oMessage = oNotes[nDisplay].NoteContent;
         var sMessage = "";
         for (var i = 0; i<oMessage.length; ++i)
         {
            sMessage += TranslateString(oMessage[i]);
         }
         oMessageDiv.html(sMessage);
         var oExpandDiv = $('<div/>', {'class':'expandNote'});
         oExpandDiv.html(TranslateString("STR_EXPAND_NOTE"));
         var oIconTD = $('<td/>',{'class':'one'});
         var oMessageTD = $('<td/>',{'class':'two'});
         var oExpandTD = $('<td/>', {'class':'three','rowspan':oNotes.length});
         oIconTD.append(oIconDiv);
         oMessageTD.append(oMessageDiv);
         oExpandTD.append(oExpandDiv);
         oNavTR.append(oIconTD);
         oNavTR.append(oMessageTD);
         oNavTR.append(oExpandTD);
         oTable.append(oNavTR);
         this.$el.append(oTable);
         //this.$('.noteNavigation').css('display','inline-block');
         //this.$('.allNotes').html(TranslateString("STR_VIEW_ALL"));
         this.model.set({'bShowAll':false});
      }
      //TriggerResize();
      // Since collapsed notes are only used in popups, we don't call
      // the global TriggerResize().
      this.triggerResize();
   },
*/
   triggerResize: function() {
      this.$el.trigger("resize");
   },
   
   resizeWidth: function()
   {
      //AVResize.prototype.resizeWidth.call(this);
      /*this.$('.zero').width("50%");
      var nWidth = this.$('.noteNavigation').width();
      this.$('.zero').width(nWidth);
      if (!this.model.get('bShowAll'))
      {
         this.refreshNote();
      }*/
   },
   
   resizeHeight: function()
   {
      //AVResize.prototype.resizeHeight.call(this);
      this.resizeWidth();
   }
});