<html>
<head>
<title>ADU Report Viewer</title>
<style type="text/css">
body {
   background-color:#fff;
   margin:0px;
   padding:0px;
}
body, th, td, div, p, button, select, textarea, input {
   font-family:Arial,sans-serif;
}

body,td,input,button,th,caption {
   font-size:70%;
}
* html body,* html td,* html input,* html button,* html th {
   font-size:67%;
}
select {
   font-size:100%;
}

/*  percentage fonts must be used carefully */
/* for ie we dont want to set body td, body th, back to 100%, as these dont properly inherit from the body in the first place.  */
/*  oddly enough though, td does inherit from div in IE, although not from anything else.*/
div td,body input, body button,
td input, td button, th input, th button, 
body div,body table, body td, body th, body caption{
   font-size:100%;
}

hr {
   border:0px;
   height:1px;
   overflow:hidden;
   color:#999;
   background-color:#999;
   margin-top:6px;
   margin-bottom:6px;
}
* html hr {
   margin-top:-6px;
   position:relative;
   top:6px;
}

form {
   display:inline;
}
span.whiteSpacer {
   font-size:8px;
}
select.medium {
   width:145px;
}
input.medium {
   width:145px;
}
option {
   overflow: visible;
   clip: auto;
}

div.clearFloats {
   clear:both;
   height:1px;
   overflow:hidden;
   margin-bottom:-1px;
}

/* table borders, shared by all tables */
.dataTable {
 border:1px solid #968F89;
 border-top-width:0px;
 width:100%;
}
.dataTable td {
 background-color:#eeeeee;
 border-top:1px solid #ccc;
 vertical-align:top;
 padding:2px 5px 1px 5px;
}
.dataTable tr td.sorted {
 background-color:#dfdfdf;
}
.dataTable tr.rowHighlight td {
 background-color:#9cf;
}
tr.altRowColor td { 
 background-color:#f5f5f5;
}
tr.captionRow th {
 background-color:#716B66;
 font-weight:bold;
 text-align:left;
 vertical-align:top;
 padding:3px 5px 2px 5px;
 color:#fff; 
 border-right:1px solid #ccc;
}
/* table links */
tr.captionRow a:link,tr.captionRow a:visited,tr.captionRow a:active,tr.captionRow a:hover ,
div.visualColumnHeader a:link,div.visualColumnHeader a:visited,div.visualColumnHeader a:active,div.visualColumnHeader a:hover {
 color:#fff;
 text-decoration:none;
}
.nestedTable { 
   color: #0000cd;
   border: 0px solid #968F89;    }
.nestedTable td { 
   background-color: white;    }
caption { 
   background-color:#716B66;
   font-weight:bold;
   text-align:left;
   vertical-align:top;
   padding:3px 5px 2px 5px;
   color:#fff; 
}
</style>

   <script language="javascript">
      function onLoadHandler()
      {
         onResizeHandler();
      }
      
      function onResizeHandler()
      {
         var containerDIV = document.getElementById("ADU_CONTAINER_AREA");
         containerDIV.style.height = document.body.clientHeight + "px";
         containerDIV.style.width = document.body.clientWidth + "px";
      }
      
      var g_documentXML;
      var g_navigatorXSLProcessor;
      function AsyncLoadXML(documentXMLPath, documentXSLPath, documentDOMID)
      {
         if (window.ActiveXObject)
         {
            // Initialize the document XSL object
            var documentXSL = new ActiveXObject("MSXML2.FreeThreadedDOMDocument");
            documentXSL.async = false;
            documentXSL.load(documentXSLPath);
            
            // Initialize the XML document...
            g_documentXML = new ActiveXObject("MSXML2.DOMDocument");      
            g_documentXML.onreadystatechange = function()
            {
               if (g_documentXML.readyState == 4) // 4 : Document finished loading
               {
                  // Do some error checking
                  if (g_documentXML.parseError.errorCode != 0)
                  {
                     var xmlError = g_documentXML.parseError;
                     var errorReport = "<DIV style=\"color:red;\">";
                     errorReport += "<BR/><H2>Internal XML Error</H2>";
                     errorReport += "Code: " + xmlError.errorCode + "<BR/>";
                     errorReport += "Reason: " + xmlError.reason + "<BR/>";
                     errorReport += "Line: " + xmlError.line + "<BR/>";
                     errorReport += "File position: " + xmlError.filepos + "<BR/>";
                     errorReport += "</DIV>";
                     document.getElementById(documentDOMID).innerHTML = errorReport;
                  }
                  else
                  {
                     // Apply the XML transform
                     g_documentXSLProcessor.transform();      
                     document.getElementById(documentDOMID).innerHTML = g_documentXSLProcessor.output;
                  }
               }         
            }
            g_documentXML.async = true; 
      
            // Initialize the XSLTemplate document...
            var XSLTemplate = new ActiveXObject("MSXML2.XSLTemplate");
            XSLTemplate.stylesheet = documentXSL;
            g_documentXSLProcessor = XSLTemplate.createProcessor();
            g_documentXSLProcessor.input = g_documentXML; 
   		   
            // Finally, load the XML document asynchronously...
            g_documentXML.load(documentXMLPath);  
         }
         else if( document.implementation && document.implementation.createDocument )
         {
            // This code is for Mozilla
            // Initialize the XSL document...
            var documentXSL = document.implementation.createDocument("", "ADUReportXSL", null);                 
            documentXSL.async = false;
            documentXSL.load(documentXSLPath);  
      
            // Initialize the transform processor...
            g_documentXSLProcessor = new XSLTProcessor();
            g_documentXSLProcessor.importStylesheet(documentXSL);
   
            // Initialize and load the XML document...
            g_documentXML = document.implementation.createDocument("", "ADUReportXML", null);
            g_documentXML.async = true;
            g_documentXML.onload = function() 
            {
               // Do some error checking
               var rootTag = g_documentXML.documentElement;
               if (rootTag.tagName == "parsererror")
               {
                  var oSerialize = new XMLSerializer();
                  document.getElementById(documentDOMID).innerHTML = "<DIV style=\"font-size:10pt;text-align:left;color:red;\"><PRE>" + oSerialize.serializeToString(g_documentXML) + "</PRE></DIV>";
               }
               else
               {
                  var htmlDoc = g_documentXSLProcessor.transformToDocument(g_documentXML);
                  var oSerialize = new XMLSerializer(); // Only in Moz         
                  document.getElementById(documentDOMID).innerHTML = oSerialize.serializeToString(htmlDoc);       
               }
            }      
            g_documentXML.load(documentXMLPath);
         }
      }

      function ResetADUReportSections()
      {
      }

      function ScrollToADUReportTop()
      {
         var container = document.getElementById("ADU_CONTAINER_AREA");
         container.scrollTop = 0;
      }

      function ScrollToADUReportDevice(sID)
      {
         var elem = document.getElementById(sID);
         var elementOffsetTop = elem.offsetTop;      
         var container = document.getElementById("ADU_CONTAINER_AREA");
         if(container)
         {
            container.scrollTop = elementOffsetTop;
         }
         else
         {
            window.scrollTo(0, elementOffsetTop);         
         }
      }
      
      function ScrollToADUReportDeviceSection(sID, sectionID)
      {
         var elem = document.getElementById(sID);
         var sections = elem.getElementsByTagName("TR");
         var container = document.getElementById("ADU_CONTAINER_AREA");
         for (var j = 0; j < sections.length; j++)
         {
            if (sections[j].className == "captionRow")
            {
              if (sections[j].id == sectionID)
              {
                 container.scrollTop = elem.offsetTop + sections[j].offsetTop;
                 break;
              }
            }
         }
      }

      function AddFilterToIcon(parentID, iconFileName, iconHeight, iconWidth, iconClass, iconID)
      {
      }   
   </script>   
</head>
<body onload="onLoadHandler();" onresize="onResizeHandler();" scroll="no">
<div id="ADU_CONTAINER_AREA" style="position:absolute;overflow:auto;background:#fff;">
   <!.DiagHtmlOutput>
</div>
</body>
</html>
